// NOTE:  Not all constant values are imported for this instrument driver. 
// Refer to nifgen.h for the full set of constant values for properties and parameters.


//------------------------------------------------------------------------------
// <autogenerated>
//     This code was generated by Measurement Studio.
//     Runtime Version: 1.1.4322.2032
//
//     Changes to this file may cause incorrect behavior and will be lost if 
//     the code is regenerated.
// </autogenerated>
//------------------------------------------------------------------------------

namespace InstrumentDriverInterop.Ivi
{
    using System;
    using System.Runtime.InteropServices;
    
    
    public class niFgen : object, System.IDisposable
    {
        
        private System.IntPtr _handle;
        
        private bool _disposed = true;
        
        ~niFgen(){Dispose(false);}

        /// <summary>
        /// Performs the following initialization actions:
        /// 
        /// - Creates a new IVI instrument driver session.
        /// - Opens a session to the specified device using the interface and address that you specify for the resourceName parameter.
        /// - If the IDQuery parameter is set to VI_TRUE, this function queries the device ID and checks that the ID is valid for NI-FGEN.
        /// - If the resetDevice parameter is set to VI_TRUE, this function resets the device to a known state.
        /// - Sends initialization commands to set the device to the state necessary for the operation of NI-FGEN.
        /// - Returns a session handle that you can use to identify the device in all subsequent NI-FGEN function calls.
        /// </summary>
        /// <param name="Resource_Name">
        /// Resource Name specifies the resource name of the device to initialize.
        ///  
        /// Examples 
        /// -----------------------------------------------------------
        /// DAQ::1              Traditional NI-DAQ device, 
        ///                     device number = 1
        /// DAQ::2              NI-DAQmx device, device name = "2"
        /// myDAQmxDevice       NI-DAQmx device, device name = 
        ///                     "myDAQmxDevice"
        /// DAQ::myDAQmxDevice  NI-DAQmx device, device name = 
        ///                     "myDAQmxDevice"
        /// myLogicalName       IVI logical name or virtual instrument, 
        ///                     name = "myLogicalName"
        /// 
        /// For Traditional NI-DAQ devices, the syntax is "DAQ::n", where n is the device number assigned by MAX.
        ///  
        /// For NI-DAQmx devices, the syntax is just the device name specified in MAX. Typical default names for NI-DAQmx devices in MAX are "Dev1" or "PXI1Slot1". You can rename an NI-DAQmx device by right clicking on the name in MAX and entering a new name.
        ///  
        /// An alternate syntax is allowed for NI-DAQmx devices, which consists of "DAQ::" followed by the NI-DAQmx device name. This naming convention allows using an NI-DAQmx device in an application that may have originally been designed for a Traditional NI-DAQ device. For example, if the application expects "DAQ::1", you can rename the device to "1" in MAX and pass in "DAQ::1" for the resource name. 
        /// 
        /// If you use the "DAQ::n" syntax and an NI-DAQmx device name already exists with the same name, the NI-DAQmx device will be matched first. 
        /// 
        /// You can also pass in the name of a virtual instrument or logical name that you configure with the IVI Configuration utility. The virtual instrument identifies a specific device and specifies the initial settings for the session. A logical name identifies a particular virtual instrument. 
        /// 
        /// </param>
        /// <param name="ID_Query">
        /// Specify whether you want NI-FGEN to perform an ID query.
        /// 
        /// When you set this parameter to VI_TRUE, NI-FGEN verifies that the device you initialize is a type that it supports.  
        /// 
        /// Circumstances can arise where sending an ID query to the device is undesirable. When you set this parameter to VI_FALSE, the function initializes the device without performing an ID query.
        /// 
        /// Defined Values
        /// 
        /// VI_TRUE  - Perform ID Query
        /// VI_FALSE - Skip ID Query
        /// 
        /// Default Value: VI_TRUE
        /// </param>
        /// <param name="Reset_Device">
        /// Specify whether you want to reset the device during the initialization procedure.
        /// 
        /// Defined Values
        /// 
        /// VI_TRUE  - Reset Device 
        /// VI_FALSE - Do Not Reset Device
        /// 
        /// Default Value: VI_TRUE
        /// </param>
        /// <param name="Instrument_Handle">
        /// Returns a session handle that you can use to identify the device in all subsequent NI-FGEN function calls.
        /// </param>
        public niFgen(string Resource_Name, bool ID_Query, bool Reset_Device)
        {
            int pInvokeResult = PInvoke.init(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), out this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            this._disposed = false;
        }
        
        /// <summary>
        /// Performs the following initialization actions:
        /// 
        /// - Creates a new IVI instrument session and optionally sets the initial state of the following session attributes: RangeCheck, Cache, Simulate, and RecordCoersions.         
        /// - Opens a session to the specified device using the interface and address that you specify for the resourceName parameter.
        /// - If the resetDevice parameter is set to VI_TRUE, this function resets the device to a known state.
        /// - Sends initialization commands to set the instrument to the state necessary for NI-FGEN operation.
        /// - Returns a session handle that you can use to identify the device in all subsequent NI-FGEN function calls.
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// Resource Name specifies the resource name of the device to initialize.
        ///  
        /// Examples 
        /// -----------------------------------------------------------
        /// DAQ::1              Traditional NI-DAQ device, 
        ///                     device number = 1
        /// DAQ::2              NI-DAQmx device, device name = "2"
        /// myDAQmxDevice       NI-DAQmx device, device name = 
        ///                     "myDAQmxDevice"
        /// DAQ::myDAQmxDevice  NI-DAQmx device, device name = 
        ///                     "myDAQmxDevice"
        /// myLogicalName       IVI logical name or virtual instrument, 
        ///                     name = "myLogicalName"
        /// 
        /// For Traditional NI-DAQ devices, the syntax is "DAQ::n", where n is the device number assigned by MAX.
        ///  
        /// For NI-DAQmx devices, the syntax is just the device name specified in MAX. Typical default names for NI-DAQmx devices in MAX are "Dev1" or "PXI1Slot1". You can rename an NI-DAQmx device by right clicking on the name in MAX and entering a new name.
        ///  
        /// An alternate syntax is allowed for NI-DAQmx devices, which consists of "DAQ::" followed by the NI-DAQmx device name. This naming convention allows using an NI-DAQmx device in an application that may have originally been designed for a Traditional NI-DAQ device. For example, if the application expects "DAQ::1", you can rename the device to "1" in MAX and pass in "DAQ::1" for the resource name. 
        /// 
        /// If you use the "DAQ::n" syntax and an NI-DAQmx device name already exists with the same name, the NI-DAQmx device will be matched first. 
        /// 
        /// You can also pass in the name of a virtual instrument or logical name that you configure with the IVI Configuration utility. The virtual instrument identifies a specific device and specifies the initial settings for the session. A logical name identifies a particular virtual instrument. 
        /// 
        /// </param>
        /// <param name="ID_Query">
        /// Specify whether you want NI-FGEN to perform an ID query.
        /// 
        /// When you set this parameter to VI_TRUE, NI-FGEN verifies that the device that you initialize is a type that it supports.  
        /// 
        /// Circumstances can arise where sending an ID query to the device is undesirable. When you set this parameter to VI_FALSE, the function initializes the device without performing an ID query.
        /// 
        /// Defined Values
        /// 
        /// VI_TRUE  - Perform ID Query
        /// VI_FALSE - Skip ID Query
        /// 
        /// Default Value: VI_TRUE
        /// 
        /// 
        /// </param>
        /// <param name="Reset_Device">
        /// Specify whether you want to reset the device during the initialization procedure.
        /// 
        /// Defined Values
        /// 
        /// VI_TRUE  - Reset Device
        /// VI_FALSE - Do not Reset
        /// 
        /// Default Value: VI_TRUE
        /// </param>
        /// <param name="Option_String">
        /// You can use this parameter to set the initial value of certain session attributes. 
        /// 
        /// The syntax for Option String is 
        /// 
        ///    &lt;attributeName&gt;=&lt;value&gt;
        /// 
        /// where
        /// 
        ///    attributeName = the name of the attribute
        ///    value = the value to which the attribute is set. 
        /// 
        /// To set multiple attributes, separate them with a comma.  
        /// 
        /// If you pass NULL or an empty string for this parameter, the session uses the default values for these attributes. You can override the default values by assigning a value explicitly in a string that you pass for this parameter. 
        /// 
        /// You do not have to specify all of the attributes and may leave any of them out. However, if you do not specify one of the attributes, its default value is used.  
        /// 
        /// If simulation is enabled (Simulate=1), you may specify the device that you want to simulate. To specify a device, enter the following syntax in Option String.
        /// 
        /// DriverSetup=Model:&lt;driver model number&gt;;BoardType:&lt;module type&gt;;MemorySize:&lt;size of onboard memory in bytes&gt;
        /// 
        /// Examples
        /// 
        /// Device      Option String Syntax 
        /// ------------------------------------------------
        /// NI PXI-5404 DriverSetup=Model:5404;BoardType:PXI
        /// NI PCI-5411 DriverSetup=Model:5411;BoardType:
        ///             PCI;MemorySize:8000000
        /// 
        /// Attributes and Defined Values
        /// 
        /// Attribute Name    Attribute                 Values
        /// --------------------------------------------------------------
        /// RangeCheck        NIFGEN_ATTR_RANGE_CHECK   VI_TRUE, VI_FALSE
        /// Cache             NIFGEN_ATTR_CACHE         VI_TRUE, VI_FALSE
        /// Simulate          NIFGEN_ATTR_SIMULATE      VI_TRUE, VI_FALSE
        /// 
        /// Default Values: "Simulate=0,RangeCheck=1,Cache=1"
        /// </param>
        /// <param name="Instrument_Handle">
        /// Returns a session handle that you can use to identify the device in all subsequent NI-FGEN function calls.
        /// </param>
        public niFgen(string Resource_Name, bool ID_Query, bool Reset_Device, string Option_String)
        {
            int pInvokeResult = PInvoke.InitWithOptions(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), Option_String, out this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            this._disposed = false;
        }
        
        /// <summary>
        /// Creates and initializes a special FGEN external calibration session.  The ViSession returned is an FGEN session that can be used to configure the device using normal attributes and functions.  However, flags have been set that allow the user to program an external calibration procedure using the special calibration attributes and functions.
        /// </summary>
        /// <param name="Resource_Name">
        /// Resource Name specifies the resource name of the device to initialize.
        ///  
        /// Examples 
        /// -----------------------------------------------------------
        /// DAQ::1              Traditional NI-DAQ device, 
        ///                     device number = 1
        /// DAQ::2              NI-DAQmx device, device name = "2"
        /// myDAQmxDevice       NI-DAQmx device, device name = 
        ///                     "myDAQmxDevice"
        /// DAQ::myDAQmxDevice  NI-DAQmx device, device name = 
        ///                     "myDAQmxDevice"
        /// myLogicalName       IVI logical name or virtual instrument, 
        ///                     name = "myLogicalName"
        /// 
        /// For Traditional NI-DAQ devices, the syntax is "DAQ::n", where n is the device number assigned by MAX.
        ///  
        /// For NI-DAQmx devices, the syntax is just the device name specified in MAX. Typical default names for NI-DAQmx devices in MAX are "Dev1" or "PXI1Slot1". You can rename an NI-DAQmx device by right clicking on the name in MAX and entering a new name.
        ///  
        /// An alternate syntax is allowed for NI-DAQmx devices, which consists of "DAQ::" followed by the NI-DAQmx device name. This naming convention allows using an NI-DAQmx device in an application that may have originally been designed for a Traditional NI-DAQ device. For example, if the application expects "DAQ::1", you can rename the device to "1" in MAX and pass in "DAQ::1" for the resource name. 
        /// 
        /// If you use the "DAQ::n" syntax and an NI-DAQmx device name already exists with the same name, the NI-DAQmx device will be matched first. 
        /// 
        /// You can also pass in the name of a virtual instrument or logical name that you configure with the IVI Configuration utility. The virtual instrument identifies a specific device and specifies the initial settings for the session. A logical name identifies a particular virtual instrument. 
        /// 
        /// </param>
        /// <param name="Password">
        /// The calibration password required to open an external calibration session to the device.
        /// </param>
        /// <param name="Instrument_Handle">
        /// Returns a session handle that you use to identify the instrument in all subsequent NI-FGEN function calls.
        /// </param>
        public niFgen(string Resource_Name, string Password)
        {
            int pInvokeResult = PInvoke.InitExtCal(Resource_Name, Password, out this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            this._disposed = false;
        }
        
        /// <summary>
        /// Causes a transition to the Committed state. This function verifies attribute values, reserves the device, and commits the attribute values to the device. If the attributes values are all valid, the device configuration matches the session configuration.
        /// 
        /// In the Committed state, waveforms, scripts, and sequences can be loaded into memory. If any attributes are changed, NI-FGEN implicitly transitions back to the Idle state. This function has no effect if the device is already in the Committed or Generating states, and returns a successful status value.
        /// 
        /// Some benefits of this function are as follows:
        /// 
        /// - niFgen_InitiateGeneration occurs faster because the device 
        ///   is configured.
        /// - Routes are committed, so signals are exported or imported.
        /// - The PLL and all DCMs are locked.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list defines the ranges of additional status codes that NI-FGEN can return with the different include files that contain the defined constants for the particular status codes.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// </returns>
        public int Commit()
        {
            int pInvokeResult = PInvoke.Commit(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Resets the instrument to a known state. 
        /// 
        /// Note: For the NI 5421, this function aborts the generation, clears all routes, and resets session attributes to the default values. This function does not, however, commit the session attributes or configure the device to its default state.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int reset()
        {
            int pInvokeResult = PInvoke.reset(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Determines how the signal generator produces waveforms.  NI signal generators currently support only one value:  continuous.  To control trigger mode, use niFgen_ConfigureTriggerMode instead.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to configure the operation mode.
        /// 
        /// Defined Value
        /// 
        /// 0
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Operation_Mode">
        /// Pass the operation mode you want the signal generator to use.  NI-FGEN sets NIFGEN_ATTR_OPERATION_MODE to this value.  
        /// 
        /// Only one value, NIFGEN_VAL_OPERATE_CONTINUOUS, is currently valid.  A second value, NIFGEN_VAL_OPERATE_BURST, is listed for IVI compatibility but is not supported by NI signal generators.  To control trigger mode on NI signal generators, use niFgen_ConfigureTriggerMode instead.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_OPERATE_CONTINUOUS
        /// NIFGEN_VAL_OPERATE_BURST
        /// 
        /// Default Value: NIFGEN_VAL_OPERATE_CONTINUOUS
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes:
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureOperationMode(string Channel_Name, int Operation_Mode)
        {
            int pInvokeResult = PInvoke.ConfigureOperationMode(this._handle, Channel_Name, Operation_Mode);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the output mode of the signal generator. The output mode determines how the signal generator produces waveforms.
        /// 
        /// For example, you can select to output a standard waveform, an arbitrary waveform, or a sequence of arbitrary waveforms.  
        /// 
        /// Note: The signal generator must not be in the Generating state when you call this function.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Output_Mode">
        /// Pass the output mode that you want the signal generator to use. NI-FGEN sets NIFGEN_ATTR_OUTPUT_MODE to this value. The value you specify determines which functions and attributes you can use to configure the waveform the signal generator produces.
        /// 
        /// When you set output mode to NIFGEN_VAL_OUTPUT_FUNC, you can use the following functions to configure the waveform:
        /// 
        /// - niFgen_ConfigureStandardWaveform
        /// - niFgen_DefineUserStandardWaveform
        /// - niFgen_ClearUserStandardWaveform
        /// - niFgen_ConfigureFrequency
        /// - niFgen_ConfigureAmplitude
        /// 
        /// You can also set the following attributes:
        /// 
        /// - NIFGEN_ATTR_FUNC_WAVEFORM     
        /// - NIFGEN_ATTR_FUNC_AMPLITUDE 
        /// - NIFGEN_ATTR_FUNC_DC_OFFSET   
        /// - NIFGEN_ATTR_FUNC_FREQUENCY 
        /// - NIFGEN_ATTR_FUNC_START_PHASE   
        /// - NIFGEN_ATTR_FUNC_DUTY_CYCLE_HIGH
        /// 
        /// When you set Output Mode to NIFGEN_VAL_OUTPUT_FREQ_LIST, you can use the following functions to configure the waveform:
        /// 
        /// - niFgen_CreateFreqList
        /// - niFgen_ClearFreqList
        /// - niFgen_QueryFreqListCapabilities
        /// - niFgen_ConfigureFreqList
        /// - niFgen_ConfigureAmplitude
        /// 
        /// You can also set the following attributes:
        /// 
        /// - NIFGEN_ATTR_FREQ_LIST_HANDLE
        /// - NIFGEN_ATTR_FUNC_AMPLITUDE
        /// - NIFGEN_ATTR_FUNC_DC_OFFSET
        /// - NIFGEN_ATTR_FUNC_START_PHASE
        /// 
        /// When you set Output Mode to NIFGEN_VAL_OUTPUT_ARB, you can use the following functions to configure the waveform:
        /// 
        /// - niFgen_QueryArbWfmCapabilities
        /// - niFgen_CreateWaveformF64
        /// - niFgen_CreateWaveformI16
        /// - niFgen_CreateWaveformFromFileI16
        /// - niFgen_CreateWaveformFromFileF64
        /// - niFgen_CreateWaveformFromFileHWS
        /// - niFgen_CreateBin16ArbWaveform
        /// - niFgen_ClearArbWaveform
        /// - niFgen_ClearArbMemory
        /// - niFgen_ConfigureSampleRate
        /// - niFgen_ConfigureGain
        /// - niFgen_ConfigureArbWaveform
        /// - niFgen_ConfigureClockMode 
        /// 
        /// You can also set the following attributes:
        /// 
        /// - NIFGEN_ATTR_ARB_WAVEFORM_HANDLE  
        /// - NIFGEN_ATTR_ARB_GAIN
        /// - NIFGEN_ATTR_ARB_OFFSET  
        /// - NIFGEN_ATTR_ARB_SAMPLE_RATE 
        /// - NIFGEN_ATTR_CLOCK_MODE
        /// 
        /// When you set Output Mode to NIFGEN_VAL_OUTPUT_SEQ, you can use the following functions to configure the sequence:
        /// 
        /// - niFgen_QueryArbWfmCapabilities 
        /// - niFgen_AllocateWaveform 
        /// - niFgen_CreateWaveformF64
        /// - niFgen_CreateWaveformI16
        /// - niFgen_CreateWaveformFromFileI16
        /// - niFgen_CreateWaveformFromFileF64
        /// - niFgen_CreateWaveformFromFileHWS 
        /// - niFgen_SetWaveformNextWritePosition 
        /// - niFgen_WriteWaveform 
        /// - niFgen_WriteBinary16Waveform 
        /// - niFgen_ClearArbWaveform 
        /// - niFgen_ClearArbMemory 
        /// - niFgen_QueryArbSeqCapabilities 
        /// - niFgen_CreateArbSequence 
        /// - niFgen_CreateAdvancedArbSequence 
        /// - niFgen_ClearArbSequence 
        /// - niFgen_ConfigureSampleRate 
        /// - niFgen_ConfigureClockMode 
        /// - niFgen_ConfigureArbSequence 
        /// 
        /// 
        /// You can also set the following attributes:
        /// 
        /// - NIFGEN_ATTR_ARB_SEQUENCE_HANDLE  
        /// - NIFGEN_ATTR_ARB_GAIN
        /// - NIFGEN_ATTR_ARB_OFFSET  
        /// - NIFGEN_ATTR_ARB_SAMPLE_RATE 
        /// - NIFGEN_ATTR_CLOCK_MODE
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_OUTPUT_FUNC
        /// NIFGEN_VAL_OUTPUT_FREQ_LIST
        /// NIFGEN_VAL_OUTPUT_ARB
        /// NIFGEN_VAL_OUTPUT_SEQ
        ///  
        /// Default Value: NIFGEN_VAL_OUTPUT_FUNC
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list defines the ranges of additional status codes that NI-FGEN can return with the different include files that contain the defined constants for the particular status codes.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureOutputMode(int Output_Mode)
        {
            int pInvokeResult = PInvoke.ConfigureOutputMode(this._handle, Output_Mode);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Enables or disables the signal generator output.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to enable or disable the output.
        /// 
        /// Defined Value
        /// 
        /// 0
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Enabled">
        /// Pass whether you want to enable or disable the output. NI-FGEN uses this value to set NIFGEN_ATTR_OUTPUT_ENABLED.
        /// 
        /// Defined Value
        /// 
        /// VI_TRUE  - Enable the output 
        /// VI_FALSE - Disable the output
        /// 
        /// Default Value: VI_TRUE
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// This driver defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureOutputEnabled(string Channel_Name, bool Enabled)
        {
            int pInvokeResult = PInvoke.ConfigureOutputEnabled(this._handle, Channel_Name, System.Convert.ToUInt16(Enabled));
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the output impedance for the channel you specify.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to set the output impedance.
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Impedance">
        /// Pass the impedance value that you want the signal generator to use.  NI-FGEN sets NIFGEN_ATTR_OUTPUT_IMPEDANCE to this value. 
        /// 
        /// Units: ohms
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_50_OHMS
        /// NIFGEN_VAL_75_OHMS
        /// 
        /// Default Value: NIFGEN_VAL_50_OHMS
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// aNI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureOutputImpedance(string Channel_Name, System.Double Impedance)
        {
            int pInvokeResult = PInvoke.ConfigureOutputImpedance(this._handle, Channel_Name, Impedance);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Enables the analog filter. You can also specify the filter correction frequency of the analog filter. This sets NIFGEN_ATTR_ANALOG_FILTER_ENABLED to VI_TRUE.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to enable the analog filter.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <param name="Filter_Correction_Frequency">
        /// Specifies the filter correction frequency of the analog filter. On the NI 5411 and NI 5431, NI-FGEN adjusts signal amplitude to compensate for the filter's attenuation at that frequency. To disable amplitude correction, set Filter_Correction_Frequency to 0. For Standard Waveform Output, the filter correction frequency should typically be set to be the same as the frequency of the standard waveform.
        /// 
        /// Units: Hz
        /// 
        /// Default Value: 0
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int EnableAnalogFilter(string Channel_Name, System.Double Filter_Correction_Frequency)
        {
            int pInvokeResult = PInvoke.EnableAnalogFilter(this._handle, Channel_Name, Filter_Correction_Frequency);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Disables the analog filter. This paramenter sets NIFGEN_ATTR_ANALOG_FILTER_ENABLED to VI_FALSE.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to disable the analog filter.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int DisableAnalogFilter(string Channel_Name)
        {
            int pInvokeResult = PInvoke.DisableAnalogFilter(this._handle, Channel_Name);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Enables the digital filter by setting NIFGEN_ATTR_DIGITAL_FILTER_ENABLED to VI_TRUE.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to enable the digital filter.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources.The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int EnableDigitalFilter(string Channel_Name)
        {
            int pInvokeResult = PInvoke.EnableDigitalFilter(this._handle, Channel_Name);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Disables the digital filter. This sets the NIFGEN_ATTR_DIGITAL_FILTER_ENABLED attribute to VI_FALSE.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to disable the digital filter.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int DisableDigitalFilter(string Channel_Name)
        {
            int pInvokeResult = PInvoke.DisableDigitalFilter(this._handle, Channel_Name);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Enables digital patterning on the signal generator. This sets NIFGEN_ATTR_DIGITAL_PATTERN_ENABLED to VI_TRUE.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to enable the digital pattern output.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int EnableDigitalPatterning(string Channel_Name)
        {
            int pInvokeResult = PInvoke.EnableDigitalPatterning(this._handle, Channel_Name);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Disables digital patterning on the signal generator. This sets NIFGEN_ATTR_DIGITAL_PATTERN_ENABLED to VI_FALSE.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to disable the digital pattern output.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int DisableDigitalPatterning(string Channel_Name)
        {
            int pInvokeResult = PInvoke.DisableDigitalPatterning(this._handle, Channel_Name);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the attributes of the signal generator that affect standard waveform generation. These attributes are the waveform, amplitude, DC offset, frequency, and start phase.
        /// 
        /// Notes:
        /// 
        /// (1) The signal generator must not be in the Generating state when you call this function.
        /// 
        /// (2) You must set the output mode to NIFGEN_VAL_OUTPUT_FUNC before calling this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to configure a standard waveform.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <param name="Waveform">
        /// Pass the standard waveform that you want the signal generator to produce. NI-FGEN sets NIFGEN_ATTR_FUNC_WAVEFORM to this value.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_WFM_SINE      - Sinusoidal waveform
        /// NIFGEN_VAL_WFM_SQUARE    - Square waveform 
        /// NIFGEN_VAL_WFM_TRIANGLE  - Triangular waveform
        /// NIFGEN_VAL_WFM_RAMP_UP   - Positive ramp waveform 
        /// NIFGEN_VAL_WFM_RAMP_DOWN - Negative ramp waveform 
        /// NIFGEN_VAL_WFM_DC        - Constant voltage
        /// NIFGEN_VAL_WFM_NOISE     - White noise
        /// NIFGEN_VAL_WFM_USER      - User-defined waveform as defined 
        ///                            with 
        ///                            niFgen_DefineUserStandardWaveform
        /// 
        /// Default Value: NIFGEN_VAL_WFM_SINE      
        /// </param>
        /// <param name="Amplitude">
        /// Pass the amplitude of the standard waveform that you want the signal generator to produce. This value is the amplitude at the output terminal. NI-FGEN sets NIFGEN_ATTR_FUNC_AMPLITUDE to this value. 
        /// 
        /// For example, to produce a waveform ranging from -5.00 V to +5.00 V, set the amplitude to 10.00 V.
        /// 
        /// Note: This parameter does not affect signal generator behavior when you set the Waveform parameter to NIFGEN_VAL_WFM_DC.
        /// 
        /// Units: Vpk-pk
        /// 
        /// Default Value: None
        /// 
        /// 
        /// </param>
        /// <param name="DC_Offset">
        /// Pass the DC offset of the standard waveform that you want the signal generator to produce. This value is the offset at the output terminal. The value is the offset from ground to the center of the waveform you specify with the waveform parameter.  NI-FGEN sets NIFGEN_ATTR_FUNC_DC_OFFSET to this value.  
        /// 
        /// For example, to configure a waveform with an amplitude of 10.00 V to range from 0.00 V to +10.00 V, set the DC Offset to 5.00 V.
        /// 
        /// Units: volts
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Frequency">
        /// Pass the frequency of the standard waveform that you want the signal generator to produce. NI-FGEN sets NIFGEN_ATTR_FUNC_FREQUENCY to this value.
        /// 
        /// Notes:
        /// 
        /// (1) This parameter does not affect signal generator behavior when you set the waveform parameter to NIFGEN_VAL_WFM_DC.
        /// 
        /// (2) Frequency ranges vary from device to device.
        /// 
        /// Units: Hz
        /// 
        /// Default Value: None
        /// </param>
        /// <param name="Start_Phase">
        /// Pass the horizontal offset of the standard waveform you want the  signal generator to produce. Specify this attribute in degrees of one waveform cycle. NI-FGEN sets NIFGEN_ATTR_FUNC_START_PHASE to this value. A start phase of 180 degrees means output generation begins halfway through the waveform. A start phase of 360 degrees offsets the output by an entire waveform cycle, which is identical to a start phase of 0 degrees.
        /// 
        /// Note: This parameter does not affect signal generator behavior when you set the waveform parameter to NIFGEN_VAL_WFM_DC.
        /// 
        /// Units: Degrees of one cycle
        /// 
        /// Default Value: 0.00 degrees
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureStandardWaveform(string Channel_Name, int Waveform, System.Double Amplitude, System.Double DC_Offset, System.Double Frequency, System.Double Start_Phase)
        {
            int pInvokeResult = PInvoke.ConfigureStandardWaveform(this._handle, Channel_Name, Waveform, Amplitude, DC_Offset, Frequency, Start_Phase);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Defines a user waveform for either standard function output or frequency list output.  
        /// 
        /// To select the waveform, set the waveform parameter to NIFGEN_VAL_WFM_USER with either niFgen_ConfigureStandardWaveform or niFgen_CreateFreqList.
        /// 
        /// The waveform data must be scaled between -1.0 and 1.0. Use the amplitude parameter to generate different output voltages. 
        /// 
        /// For the NI 5401/5411/5431, the waveform must be exactly 16,384 points. 
        /// 
        /// Note: 
        /// 
        /// You must set Output_Mode to NIFGEN_VAL_OUTPUT_FUNC or NIFGEN_VAL_OUTPUT_FREQ_LIST using niFgen Configure Output Mode before calling this function.  
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to configure an arbitrary sequence.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <param name="Waveform_Size">
        /// Pass the size of the arbitrary waveform you want to create.
        /// 
        /// For the NI 5401/5411/5431, the waveform must be exactly 16,384 points.
        /// 
        /// Default Value: 16384
        /// 
        /// </param>
        /// <param name="Waveform_Data_Array">
        /// Specify the array of data you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in the waveformSize parameter.
        /// 
        /// You must normalize the data points in the array to be between -1.00 and +1.00.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int DefineUserStandardWaveform(string Channel_Name, int Waveform_Size, System.Double[] Waveform_Data_Array)
        {
            int pInvokeResult = PInvoke.DefineUserStandardWaveform(this._handle, Channel_Name, Waveform_Size, Waveform_Data_Array);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Clears the user-defined waveform created by niFgen_DefineUserStandardWaveform.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name from which you want to clear the waveform.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ClearUserStandardWaveform(string Channel_Name)
        {
            int pInvokeResult = PInvoke.ClearUserStandardWaveform(this._handle, Channel_Name);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the frequency of the standard waveform that you want the signal generator to produce.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to configure a standard waveform.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <param name="Frequency">
        /// Pass the frequency of the standard waveform that you want the signal generator to produce. NI-FGEN sets NIFGEN_ATTR_FUNC_FREQUENCY to this value.
        /// 
        /// Notes:
        /// 
        /// (1) This parameter does not affect signal generator behavior when you set the Waveform parameter to NIFGEN_VAL_WFM_DC.
        /// 
        /// (2) For NIFGEN_VAL_WFM_SINE, the range is between 0 MHz and 16 MHz, but is between 0 MHz and 1 MHz for all other waveforms.
        /// 
        /// Units: Hz
        /// 
        /// Default Value: None
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureFrequency(string Channel_Name, System.Double Frequency)
        {
            int pInvokeResult = PInvoke.ConfigureFrequency(this._handle, Channel_Name, Frequency);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the amplitude of the standard waveform that you want the signal generator to produce.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to configure a standard waveform.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <param name="Amplitude">
        /// The peak-to-peak amplitude of the generated waveform in Volts. NI-FGEN sets NIFGEN_ATTR_FUNC_AMPLITUDE to this value.
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureAmplitude(string Channel_Name, System.Double Amplitude)
        {
            int pInvokeResult = PInvoke.ConfigureAmplitude(this._handle, Channel_Name, Amplitude);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// A frequency list consists of a list of frequencies and durations. The signal generator generates each frequency for the given amount of time and then moves on to the next frequency. When the end of the list is reached, the signal generator starts over at the beginning of the list.  
        ///  
        /// This function creates a frequency list from an array of frequencies and an array of durations. Each array must be of the same size, which must match the frequencyListLength parameter. The function returns a handle that identifies the frequency list. You can pass this handle to niFgen_ConfigureFreqList to specifiy what frequency list you want the signal generator to produce.
        /// 
        /// Notes:
        /// 
        /// (1) The signal generator must not be in the Generating state when you call this function.
        /// 
        /// (2) You must set the output mode to NIFGEN_VAL_OUTPUT_FREQ_LIST before calling this function.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Waveform">
        /// Pass the standard waveform that you want the signal generator to produce. NI-FGEN sets NIFGEN_ATTR_FUNC_WAVEFORM to this value.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_WFM_SINE      - Sinusoid waveform
        /// NIFGEN_VAL_WFM_SQUARE    - Square waveform 
        /// NIFGEN_VAL_WFM_TRIANGLE  - Triangle waveform
        /// NIFGEN_VAL_WFM_RAMP_UP   - Positive ramp waveform 
        /// NIFGEN_VAL_WFM_RAMP_DOWN - Negative ramp waveform 
        /// NIFGEN_VAL_WFM_DC        - Constant voltage
        /// NIFGEN_VAL_WFM_NOISE     - White noise
        /// NIFGEN_VAL_WFM_USER      - User-defined waveform, as defined by
        ///                            niFgen_DefineUserStandardWaveform
        /// 
        /// Default Value: NIFGEN_VAL_WFM_SINE
        /// 
        /// </param>
        /// <param name="Frequency_List_Length">
        /// The number of steps in the frequency list you want to create. The value must be between the miniumum and maximum frequency list lengths that the signal generator allows. You can obtain the minimum and maximum frequency list lengths from the minimumFrequencyListLength and maximumFrequencyListLength parameters in niFgen_QueryFreqListCapabilities.
        /// 
        /// The frequencyArray and the durationArray parameters must each be at least as long as this frequency list length.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Frequency_Array">
        /// Pass the array of frequencies to form the frequency list. The array must have at least as many elements as the value you specify in the frequencyListLength parameter. Each frequencyArray element has a corresponding durationArray element that indicates how long that frequency is repeated.  
        /// 
        /// Units: Hz
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Duration_Array">
        /// Pass the array of durations to form the frequency list. The array must have at least as many elements as the value that you specify in the frequencyListLength parameter. Each durationArray element has a corresponding frequencyArray element and indicates how long in seconds to generate the corresponding frequency.  
        /// 
        /// Units: Seconds
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Frequency_List_Handle">
        /// Returns the handle that identifies the new frequency list. You can pass this handle to niFgen_ConfigureFreqList to generate the arbitrary sequence.
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int CreateFreqList(int Waveform, int Frequency_List_Length, System.Double[] Frequency_Array, System.Double[] Duration_Array, out int Frequency_List_Handle)
        {
            int pInvokeResult = PInvoke.CreateFreqList(this._handle, Waveform, Frequency_List_Length, Frequency_Array, Duration_Array, out Frequency_List_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the attributes of the signal generator that affect frequency list generation. These attributes are the frequency list handle, amplitude, DC offset, and start phase.
        /// 
        /// Notes:
        /// 
        /// (1) The signal generator must not be in the Generating state when you call this function.
        /// 
        /// (2) You must set the output mode to NIFGEN_VAL_OUTPUT_FREQ_LIST before calling this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to configure a frequency list.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <param name="Frequency_List_Handle">
        /// Pass the handle of the frequency list that you want the signal generator to produce. NI-FGEN sets NIFGEN_ATTR_FREQ_LIST_HANDLE to this value. You can create a frequency list using niFgen_CreateFreqList. niFgen_CreateFreqList returns a handle that you use to identify the list.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Amplitude">
        /// Pass the amplitude of the standard waveform that you want the signal generator to produce. This value is the amplitude at the output terminal. NI-FGEN sets NIFGEN_ATTR_FUNC_AMPLITUDE to this value.
        /// 
        /// For example, to produce a waveform ranging from -5.00 V to +5.00 V, set the amplitude to 10.00 V.
        /// 
        /// Note: This parameter does not affect signal generator behavior when you set the Waveform parameter to NIFGEN_VAL_WFM_DC.
        /// 
        /// Units: Vpk-pk
        /// 
        /// Default Value: None
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="DC_Offset">
        /// Pass the DC offset of the standard waveform that you want the signal generator to produce. This value is the offset at the output terminal. The value is the offset from ground to the center of the waveform you specify with the Waveform parameter.  NI-FGEN sets NIFGEN_ATTR_FUNC_DC_OFFSET to this value.  
        /// 
        /// For example, to configure a waveform with an amplitude of 10.00 V to range from 0.00 V to +10.00 V, set the DC Offset to 5.00 V.
        /// 
        /// Units: volts
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Start_Phase">
        /// Pass the horizontal offset of the standard waveform that you want the signal generator to produce. Specify this parameter in degrees of one waveform cycle. NI-FGEN sets NIFGEN_ATTR_FUNC_START_PHASE to this value. A start phase of 180 degrees means output generation begins halfway through the waveform. A start phase of 360 degrees offsets the output by an entire waveform cycle. A start phase of 360 degrees is identical to a start phase of 0 degrees.
        /// 
        /// Note: This parameter does not affect signal generator behavior when you set the waveform parameter to NIFGEN_VAL_WFM_DC.
        /// 
        /// Units: Degrees of one cycle
        /// 
        /// Default Value: None
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureFreqList(string Channel_Name, int Frequency_List_Handle, System.Double Amplitude, System.Double DC_Offset, System.Double Start_Phase)
        {
            int pInvokeResult = PInvoke.ConfigureFreqList(this._handle, Channel_Name, Frequency_List_Handle, Amplitude, DC_Offset, Start_Phase);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Removes a previously created frequency list from the signal generator memory and invalidates the frequency list handle.
        /// 
        /// Note: The signal generator must not be in the Generating state when you call this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Frequency_List_Handle">
        /// Pass the handle of the frequency list you want the signal generator to remove. You create multiple frequency lists using niFgen_CreateFreqList. niFgen_CreateFreqList returns a handle that you use to identify each list.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_ALL_FLISTS - Remove all frequency lists from the signal generator.
        ///  
        /// Default Value: None
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list defines the ranges of additional status codes that NI-FGEN can return with the include files that contain the defined constants for the particular status codes.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ClearFreqList(int Frequency_List_Handle)
        {
            int pInvokeResult = PInvoke.ClearFreqList(this._handle, Frequency_List_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the attributes of the signal generator that are related to creating frequency lists.  These attributes are the maximum number of frequency lists, minimum frequency list length, maximum frequency list length, minimum frequency list duration, maximum frequency list duration, and frequency list duration quantum. 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Maximum_Number_Of_Freq_Lists">
        /// Returns the maximum number of frequency lists that the signal generator allows. NI-FGEN obtains this value from NIFGEN_ATTR_MAX_NUM_FREQ_LISTS.  
        /// 
        /// 
        /// </param>
        /// <param name="Minimum_Frequency_List_Length">
        /// Returns the minimum number of steps that the signal generator allows in a frequency list. NI-FGEN obtains this value from NIFGEN_ATTR_MIN_FREQ_LIST_LENGTH.
        /// 
        /// 
        /// </param>
        /// <param name="Maximum_Frequency_List_Length">
        /// Returns the maximum number of steps that the signal generator allows in a frequency list. NI-FGEN obtains this value from NIFGEN_ATTR_MAX_FREQ_LIST_LENGTH.
        ///  
        /// 
        /// </param>
        /// <param name="Minimum_Frequency_List_Duration">
        /// Returns the minimum duration that the signal generator allows in a step of a frequency list. NI-FGEN obtains this value from NIFGEN_ATTR_MIN_FREQ_LIST_DURATION.
        /// 
        /// 
        /// </param>
        /// <param name="Maximum_Frequency_List_Duration">
        /// Returns the maximum duration that the signal generator allows in a step of a frequency list. NI-FGEN obtains this value from NIFGEN_ATTR_MAX_FREQ_LIST_DURATION.
        ///  
        /// 
        /// </param>
        /// <param name="Frequency_List_Duration_Quantum">
        /// Returns the quantum of which all durations must be a multiple in a frequency list. NI-FGEN obtains this value from NIFGEN_ATTR_FREQ_LIST_DURATION_QUANTUM.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int QueryFreqListCapabilities(out int Maximum_Number_Of_Freq_Lists, out int Minimum_Frequency_List_Length, out int Maximum_Frequency_List_Length, out System.Double Minimum_Frequency_List_Duration, out System.Double Maximum_Frequency_List_Duration, out System.Double Frequency_List_Duration_Quantum)
        {
            int pInvokeResult = PInvoke.QueryFreqListCapabilities(this._handle, out Maximum_Number_Of_Freq_Lists, out Minimum_Frequency_List_Length, out Maximum_Frequency_List_Length, out Minimum_Frequency_List_Duration, out Maximum_Frequency_List_Duration, out Frequency_List_Duration_Quantum);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the amount of gain to apply to the waveform.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to configure the gain.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <param name="Gain">
        /// Specifies the factor by which the signal generator scales the arbitrary waveform data. When you create arbitrary waveforms, you must first normalize the data points to a range of -1.00 V to +1.00 V.  You can use this parameter to scale the arbitrary waveform to other ranges. NI-FGEN sets NIFGEN_ATTR_ARB_GAIN to this value.
        /// 
        /// For example, to configure the output signal to range from 
        /// -2.00 V to +2.00 V, set the gain to 2.00.
        /// 
        /// Units: Volts
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureGain(string Channel_Name, System.Double Gain)
        {
            int pInvokeResult = PInvoke.ConfigureGain(this._handle, Channel_Name, Gain);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the sample rate attribute, which determines the rate at which the signal generator produces arbitrary waveforms.  When you configure the signal generator to produce an arbitrary sequence, this is the sample rate for all arbitrary waveforms in the sequence.
        ///   
        /// Notes:
        /// 
        /// (1) The signal generator must not be in the Generating state when you call this function.
        /// 
        /// (2) You must set the output mode to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Sample_Rate">
        /// Pass the sample rate at which you want the signal generator to generate arbitrary waveforms. NI-FGEN sets NIFGEN_ATTR_ARB_SAMPLE_RATE to this value. 
        /// 
        /// Units: S/s
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureSampleRate(System.Double Sample_Rate)
        {
            int pInvokeResult = PInvoke.ConfigureSampleRate(this._handle, Sample_Rate);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the attributes of the signal generator that are related to creating arbitrary waveforms. These attributes are the maximum number of waveforms, waveform quantum, minimum waveform size, and maximum waveform size.
        /// 
        /// Note: If you do not want to obtain the waveform quantum, pass a value of VI_NULL for this parameter. 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Maximum_Number_of_Waveforms">
        /// Returns the maximum number of arbitrary waveforms that the signal generator allows. NI-FGEN obtains this value from NIFGEN_ATTR_MAX_NUM_WAVEFORMS.
        /// 
        /// 
        /// </param>
        /// <param name="Waveform_Quantum">
        /// The size (number of points) of each waveform must be a multiple of a constant quantum value. This parameter obtains the quantum value that the signal generator uses. NI-FGEN returns this value from NIFGEN_ATTR_WAVEFORM_QUANTUM. 
        /// 
        /// For example, when this attribute returns a value of 8, all waveform sizes must be a multiple of 8.
        /// 
        /// </param>
        /// <param name="Minimum_Waveform_Size">
        /// Returns the minimum number of points that the signal generator allows in a waveform. NI-FGEN obtains this value from NIFGEN_ATTR_MIN_WAVEFORM_SIZE.  
        /// 
        /// 
        /// </param>
        /// <param name="Maximum_Waveform_Size">
        /// Returns the maximum number of points that the signal generator allows in a waveform. NI-FGEN obtains this value from NIFGEN_ATTR_MAX_WAVEFORM_SIZE.
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int QueryArbWfmCapabilities(out int Maximum_Number_of_Waveforms, out int Waveform_Quantum, out int Minimum_Waveform_Size, out int Maximum_Waveform_Size)
        {
            int pInvokeResult = PInvoke.QueryArbWfmCapabilities(this._handle, out Maximum_Number_of_Waveforms, out Waveform_Quantum, out Minimum_Waveform_Size, out Maximum_Waveform_Size);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Creates an onboard waveform from binary F64 (floating point double) data for use in Arbitrary Waveform mode or Arbitrary Sequence mode.  The waveform handle returned  can be used later for setting the active waveform, changing the data in the waveform, building sequences of waveforms or even deleting the waveform when it is no longer needed.
        /// 
        /// Notes:  You must set the output mode to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to configure the operation mode.
        /// 
        /// Defined Value
        /// 
        /// 0
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Waveform_Size">
        /// Pass the size of the arbitrary waveform that you want created.
        /// 
        /// The size must meet the following restrictions:
        /// 
        /// - The size must be less than or equal to the maximum waveform size that the device allows.
        /// - The size must be greater than or equal to the minimum waveform size that the device allows.
        /// - The size must be an integer multiple of the device waveform quantum.
        /// 
        /// You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in niFgen_QueryArbWfmCapabilities.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Waveform_Data_Array">
        /// Specify the array of data that you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in the Waveform Size parameter.
        /// 
        /// You must normalize the data points in the array to be between -1.00 and +1.00.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Waveform_Handle">
        /// The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int CreateWaveformF64(string Channel_Name, int Waveform_Size, System.Double[] Waveform_Data_Array, out int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.CreateWaveformF64(this._handle, Channel_Name, Waveform_Size, Waveform_Data_Array, out Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Creates an onboard waveform from binary I16 data for use in Arbitrary Waveform mode or Arbitrary Sequence mode.  The waveform handle returned  can be used later for setting the active waveform, changing the data in the waveform, building sequences of waveforms or even deleting the waveform when it is no longer needed.
        /// 
        /// Notes:  You must set the output mode to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to configure the operation mode.
        /// 
        /// Defined Value
        /// 
        /// 0
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Waveform_Size">
        /// Pass the size of the arbitrary waveform that you want created.
        /// 
        /// The size must meet the following restrictions:
        /// 
        /// - The size must be less than or equal to the maximum waveform size that the instrument allows.
        /// - The size must be greater than or equal to the minimum waveform size the instrument allows.
        /// - The size must be an integer multiple of the instrument waveform quantum.
        /// 
        /// You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in niFgen_QueryArbWfmCapabilities.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Waveform_Data_Array">
        /// Specify the array of data that you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in the waveformSize parameter.
        /// 
        /// You must normalize the data points in the array to be between -32768 and +32767.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Waveform_Handle">
        /// The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int CreateWaveformI16(string Channel_Name, int Waveform_Size, short[] Waveform_Data_Array, out int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.CreateWaveformI16(this._handle, Channel_Name, Waveform_Size, Waveform_Data_Array, out Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Creates an onboard waveform from complex double-precision floating-point data for use with the NIFGEN_ATTR_OUTPUT_MODE attribute set to Arbitrary Waveform mode or Arbitrary Sequence mode on devices with the NIFGEN_ATTR_OUTPUT_ENABLED attibute set to VI_TRUE and the NIFGEN_ATTR_OSP_DATA_PROCESSING_MODE attribute set to NIFGEN_VAL_OSP_COMPLEX. The waveform handle returned by the function can be used later for setting the active waveform, changing the data in the waveform, building sequences of waveforms, or deleting the waveform when it is no longer needed.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to configure the operation mode.
        /// 
        /// Defined Value
        /// 
        /// 0
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Number_of_Samples">
        /// Pass the size of the arbitrary waveform that you want created.
        /// 
        /// The size must meet the following restrictions:
        /// 
        /// - The size must be less than or equal to the maximum waveform size that the device allows.
        /// - The size must be greater than or equal to the minimum waveform size that the device allows.
        /// - The size must be an integer multiple of the device waveform quantum.
        /// 
        /// You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in niFgen_QueryArbWfmCapabilities.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Waveform_Data_Array">
        /// Specifies the array of data you want to load into the new waveform. The array must have at least as many elements as the value that you specify in the Number of Samples parameter.
        /// 
        /// You must normalize the data points in the array to be between -1.00 and +1.00.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Waveform_Handle">
        /// The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int CreateWaveformComplexF64(string Channel_Name, int Number_of_Samples, niFgenComplexF64[] Waveform_Data_Array, out int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.CreateWaveformComplexF64(this._handle, Channel_Name, Number_of_Samples, Waveform_Data_Array, out Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function takes the binary I16 data from the specified file and creates an onboard waveform for use in Arbitrary Waveform mode or Arbitrary Sequence mode.  The waveform handle returned  can be used later for setting the active waveform, changing the data in the waveform, building sequences of waveforms or even deleting the waveform when it is no longer needed.
        /// 
        /// Notes:  
        /// 
        /// Data written by most applications in Windows (including LabWindows/CVI) is in Little Endian format.  Data written to a file from LabVIEW is in Big Endian format by default on all platforms.  (Big Endian and Little Endian refer to the way data is stored in memory, which can differ on different processors.)
        /// 
        /// The i16 data (values between -32768 and +32767) is assumed to represent -1 to +1 volts.  Use the Gain attribute to generate different voltage outputs. 
        /// 
        /// You must set the output mode to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ (using the Configure Output Mode function) before calling this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to create a waveform.
        /// 
        /// Defined Value
        /// 
        /// 0
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="FileName">
        /// The full path and name of the file where the waveform data resides.
        /// </param>
        /// <param name="Byte_Order">
        /// Specifies the byte order of the data in the file.
        /// 
        /// Defined Values:
        /// 
        /// NIFGEN_VAL_LITTLE_ENDIAN - Little Endian Data
        /// NIFGEN_VAL_BIG_ENDIAN - Big Endian Data
        /// 
        /// Default Value: NIFGEN_VAL_LITTLE_ENDIAN
        /// 
        /// 
        /// Data written by most applications in Windows (including LabWindows/CVI) is in Little Endian format.  Data written to a file from LabVIEW is in Big Endian format by default on all platforms.  (Big Endian and Little Endian refer to the way data is stored in memory, which can differ on different processors.)
        /// 
        /// </param>
        /// <param name="Waveform_Handle">
        /// The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int CreateWaveformFromFileI16(string Channel_Name, string FileName, int Byte_Order, out int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.CreateWaveformFromFileI16(this._handle, Channel_Name, FileName, Byte_Order, out Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function takes the F64 (floating point double) data from the specified file and creates an onboard waveform for use in Arbitrary Waveform mode or Arbitrary Sequence mode.  The waveform handle returned  can be used later for setting the active waveform, changing the data in the waveform, building sequences of waveforms or even deleting the waveform when it is no longer needed.
        /// 
        /// Notes:  
        /// 
        /// Data written by most applications in Windows (including LabWindows/CVI) is in Little Endian format.  Data written to a file from LabVIEW is in Big Endian format by default on all platforms.  (Big Endian and Little Endian refer to the way data is stored in memory, which can differ on different processors.)
        /// 
        /// The F64 data must be between -1.0 and +1.0.  Use the Gain attribute to generate different voltage outputs. 
        /// 
        /// You must set the output mode to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ (using the Configure Output Mode function) before calling this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to create a waveform.
        /// 
        /// Defined Value
        /// 
        /// 0
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="FileName">
        /// The full path and name of the file where the waveform data resides.
        /// </param>
        /// <param name="Byte_Order">
        /// Specifies the byte order of the data in the file.
        /// 
        /// Defined Values:
        /// 
        /// NIFGEN_VAL_LITTLE_ENDIAN - Little Endian Data
        /// NIFGEN_VAL_BIG_ENDIAN - Big Endian Data
        /// 
        /// Default Value: NIFGEN_VAL_LITTLE_ENDIAN
        /// 
        /// 
        /// Data written by most applications in Windows (including LabWindows/CVI) is in Little Endian format.  Data written to a file from LabVIEW is in Big Endian format by default on all platforms.  (Big Endian and Little Endian refer to the way data is stored in memory, which can differ on different processors.)
        /// 
        /// </param>
        /// <param name="Waveform_Handle">
        /// The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int CreateWaveformFromFileF64(string Channel_Name, string FileName, int Byte_Order, out int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.CreateWaveformFromFileF64(this._handle, Channel_Name, FileName, Byte_Order, out Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function takes the waveform data from the specified HWS (Hierarchical Waveform Storage) file and creates an onboard  waveform for use in Arbitrary Waveform mode or Arbitrary Sequence mode.  The waveform handle returned by the function can be used later for setting the active waveform, changing the data in the waveform, building sequences of waveforms or even deleting the waveform when it is no longer needed.
        /// 
        /// When the Analog Waveform Editor saves data in an HWS file, it also stores the rate, gain and offset with the data.  If the Use Rate from Waveform and Use Gain and Offset from Waveform inputs are set to True, this function will also set those properties on NI-FGEN. 
        /// 
        /// Notes:
        /// 
        /// (1)  If you choose to have this function set the gain and offset properties for you, you should NOT use the niFgen Configure Arbitrary Waveform or niFgen Configure Arbitrary Sequence functions, as they also set the gain and offset, thereby overriding the values set by this function.  Instead, use the Arbitrary Waveform Handle or Arbitrary Sequence Handle attributes in the niFgen property node.
        /// 
        /// (2) If you set the Use Rate from Waveform input to True and if Onboard Signal Processsing (OSP) is enabled, the 'rate' from the waveform is interpreted as the data rate, and FGEN sets the data rate attribute for you. In all other cases, it is interpreted as the sample rate, and FGEN sets the sample rate attribute for you.
        /// 
        /// (3) HWS files may contain I16 or DBL data (depending on how it was saved).  This function will automatically adapt to either data type.  If the file contains DBL data, it must be between -1.0 and +1.0.  Check the "Scale Data to +/- 1V" option in the Analog Waveform Editor to ensure your data is between -1.0 and +1.0.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to create a waveform.
        /// 
        /// Defined Value
        /// 
        /// 0
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="FileName">
        /// The full path and name of the file where the waveform data resides.
        /// </param>
        /// <param name="Use_Rate_From_Waveform">
        /// If you set the Use Rate from Waveform input to True and if Onboard Signal Processsing (OSP) is enabled, the 'rate' from the waveform is interpreted as the data rate, and FGEN sets the data rate attribute for you. In all other cases, it is interpreted as the sample rate, and FGEN sets the sample rate attribute for you.
        /// 
        /// Defined Values
        /// 
        /// VI_TRUE  - Use rate from waveform
        /// VI_FALSE - Do not use rate from waveform
        /// 
        /// Default Value: VI_TRUE
        /// </param>
        /// <param name="Use_Gain___Offset_From_Waveform">
        /// If this input is set to VI_TRUE (which it is by default), NI-FGEN retrieves the gain and offset values from the specified HWS file and applies them to the NI-FGEN driver.
        /// 
        /// Defined Values
        /// 
        /// VI_TRUE  - Use gain and offset from waveform
        /// VI_FALSE - Do not use gain and offset from waveform
        /// 
        /// Default Value: VI_TRUE
        /// </param>
        /// <param name="Waveform_Handle">
        /// The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int CreateWaveformFromFileHWS(string Channel_Name, string FileName, bool Use_Rate_From_Waveform, bool Use_Gain___Offset_From_Waveform, out int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.CreateWaveformFromFileHWS(this._handle, Channel_Name, FileName, System.Convert.ToUInt16(Use_Rate_From_Waveform), System.Convert.ToUInt16(Use_Gain___Offset_From_Waveform), out Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the attributes of the signal generator that affect arbitrary waveform generation. These attributes are the arbitrary waveform handle, gain, and offset.
        /// 
        /// Notes:
        /// 
        /// (1) The signal generator must not be in the Generating state when you call this function.
        /// 
        /// (2) You must set the output mode to NIFGEN_VAL_OUTPUT_ARB before calling this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to configure an arbitrary waveform.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <param name="Waveform_Handle">
        /// Pass the handle of the arbitrary waveform you want the signal generator to produce. NI-FGEN sets NIFGEN_ATTR_ARB_WAVEFORM_HANDLE to this value. You can create an arbitrary waveform using one of the following niFgen Create Waveform functions:
        /// 
        /// - niFgen_CreateWaveformF64
        /// - niFgen_CreateWaveformI16
        /// - niFgen_CreateWaveformFromFileI16
        /// - niFgen_CreateWaveformFromFileF64
        /// - niFgen_CreateWaveformFromFileHWS
        /// 
        /// These functions return a handle that you use to identify the waveform.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Gain">
        /// Specifies the factor by which the signal generator scales the arbitrary waveform data. When you create arbitrary waveforms, you must first normalize the data points to a range of -1.00 V to +1.00 V.  You can use this parameter to scale the arbitrary waveform to other ranges. NI-FGEN sets NIFGEN_ATTR_ARB_GAIN to this value.
        /// 
        /// For example, to configure the output signal to range from 
        /// -2.00 V to +2.00 V, set the gain to 2.00.
        /// 
        /// Units: Volts
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Offset">
        /// Specifies the value the signal generator adds to the arbitrary waveform data. When you create arbitrary waveforms, you must first normalize the data points to a range of -1.00 V to +1.00 V. You can use this parameter to shift the range of the arbitrary waveform. NI-FGEN sets NIFGEN_ATTR_ARB_OFFSET to this value.
        /// 
        /// For example, to configure the output signal to range from 0.00 V to 2.00 V instead of -1.00 V to 1.00 V, set the offset to 1.00.
        /// 
        /// Units: Volts
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list defines the ranges of additional status codes that NI-FGEN can return with the include files that contain the defined constants for the particular status codes
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureArbWaveform(string Channel_Name, int Waveform_Handle, System.Double Gain, System.Double Offset)
        {
            int pInvokeResult = PInvoke.ConfigureArbWaveform(this._handle, Channel_Name, Waveform_Handle, Gain, Offset);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Removes a previously created arbitrary waveform from the signal generator memory and invalidates the waveform handle.
        /// 
        /// Note: The signal generator must not be in the Generating state when you call this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Waveform_Handle">
        /// Pass the handle of the arbitrary waveform that you want the signal generator to remove. You can create multiple arbitrary waveforms using one of the following niFgen Create Waveform functions: 
        /// 
        /// - niFgen_CreateWaveformF64
        /// - niFgen_CreateWaveformI16
        /// - niFgen_CreateWaveformFromFileI16
        /// - niFgen_CreateWaveformFromFileF64
        /// - niFgen_CreateWaveformFromFileHWS
        /// 
        /// These functions return a handle that you use to identify each waveform.
        /// 
        /// Defined Value
        /// 
        /// NIFGEN_VAL_ALL_WAVEFORMS - Remove all waveforms from the signal generator.
        ///     
        /// Default Value: None
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list defines the ranges of additional status codes that NI-FGEN can return with the different include files that contain the defined constants for the particular status codes.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ClearArbWaveform(int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.ClearArbWaveform(this._handle, Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the attributes of the signal generator that are related to creating arbitrary sequences.  These attributes are the maximum number of sequences, minimum sequence length, maximum sequence length, and maximum loop count.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Maximum_Number_of_Sequences">
        /// Returns the maximum number of arbitrary waveform sequences that the signal generator allows.  NI-FGEN obtains this value from NIFGEN_ATTR_MAX_NUM_SEQUENCES.  
        /// 
        /// 
        /// </param>
        /// <param name="Minimum_Sequence_Length">
        /// Returns the minimum number of arbitrary waveforms the signal generator allows in a sequence.  NI-FGEN obtains this value from NIFGEN_ATTR_MIN_SEQUENCE_LENGTH.
        /// 
        /// 
        /// </param>
        /// <param name="Maximum_Sequence_Length">
        /// Returns the maximum number of arbitrary waveforms the signal generator allows in a sequence.  NI-FGEN obtains this value from NIFGEN_ATTR_MAX_SEQUENCE_LENGTH.
        ///  
        /// 
        /// </param>
        /// <param name="Maximum_Loop_Count">
        /// Returns the maximum number of times the signal generator can repeat an arbitrary waveform in a sequence.  NI-FGEN obtains this value from NIFGEN_ATTR_MAX_LOOP_COUNT.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status    Description
        /// -------------------------------------------------
        /// ERRORS
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources.  The following list defines the ranges of additional status codes that NI-FGEN can return.  with the include files that contain the defined constants for the particular status codes
        ///           
        /// Numeric Range (in Hex)   Include Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
        /// 
        /// 
        /// </returns>
        public int QueryArbSeqCapabilities(out int Maximum_Number_of_Sequences, out int Minimum_Sequence_Length, out int Maximum_Sequence_Length, out int Maximum_Loop_Count)
        {
            int pInvokeResult = PInvoke.QueryArbSeqCapabilities(this._handle, out Maximum_Number_of_Sequences, out Minimum_Sequence_Length, out Maximum_Sequence_Length, out Maximum_Loop_Count);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// An arbitrary sequence consists of multiple waveforms. For each waveform, you can specify the number of times that the signal generator produces the waveform before proceeding to the next waveform. The number of times to repeat a specific waveform is called the loop count.
        ///  
        /// This function creates an arbitrary sequence from an array of waveform handles and an array of corresponding loop counts. The function returns a handle that identifies the sequence. You pass this handle to niFgen_ConfigureArbSequence to specify what arbitrary sequence you want the signal generator to produce.
        /// 
        /// Note:  You must set the output mode to NIFGEN_VAL_OUTPUT_SEQ before calling this function.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Sequence_Length">
        /// Pass the number of waveforms in the new arbitrary sequence that you want to create. The value you pass must be between the minimum and maximum sequence lengths that the signal generator allows. You can obtain the minimum and maximum sequence lengths from the minimumSequenceLength and maximumSequenceLength parameters in niFgen_QueryArbSeqCapabilities.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Waveform_Handles_Array">
        /// Pass the array of waveform handles from which you want to create a new arbitrary sequence. The array must have at least as many elements as the value that you specify in the Sequence_Length parameter. Each waveformHandlesArray element has a corresponding loopCountsArray element that indicates how many times that waveform is repeated. You obtain waveform handles when you create arbitrary waveforms with niFgen_AllocateWaveform or one of the following niFgen_CreateWaveform functions:
        /// 
        /// - niFgen_CreateWaveformF64
        /// - niFgen_CreateWaveformI16
        /// - niFgen_CreateWaveformFromFileI16
        /// - niFgen_CreateWaveformFromFileF64
        /// - niFgen_CreateWaveformFromFileHWS
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Loop_Counts_Array">
        /// Pass the array of loop counts you want to use to create a new arbitrary sequence. The array must have at least as many elements as the value that you specify in the Sequence Length parameter. Each loopCountsArray element corresponds to a waveformHandlesArray element and indicates how many times to repeat that waveform. Each element of the loopCountsArray must be less than or equal to the maximum number of loop counts that the signal generator allows. You can obtain the maximum loop count from the maximumLoopCount parameter in niFgen_QueryArbSeqCapabilities.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Sequence_Handle">
        /// Returns the handle that identifies the new arbitrary sequence.  You can pass this handle to niFgen_ConfigureArbSequence to generate the arbitrary sequence.
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int CreateArbSequence(int Sequence_Length, long[] Waveform_Handles_Array, long[] Loop_Counts_Array, out int Sequence_Handle)
        {
            int pInvokeResult = PInvoke.CreateArbSequence(this._handle, Sequence_Length, Waveform_Handles_Array, Loop_Counts_Array, out Sequence_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// An arbitrary sequence consists of multiple waveforms.  For each waveform, you specify the number of times the signal generator produces the waveform before proceeding to the next waveform.  The number of times to repeat a specific waveform is called the loop count.
        ///  
        /// This function creates an arbitrary sequence from an array of waveform handles and an array of corresponding loop counts.  The function returns a handle that identifies the sequence.  You pass this handle to niFgen_ConfigureArbSequence to specify what arbitrary sequence you want the signal generator to produce.
        /// 
        /// niFgen_CreateAdvancedArbSequence extends on niFgen_CreateArbSequence by adding the ability to set the number of samples in each sequence step and to set marker locations.   
        /// 
        /// Notes:  You must set the output mode to NIFGEN_VAL_OUTPUT_SEQ before calling this function.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Sequence_Length">
        /// Pass the number of waveforms in the new arbitrary sequence that you want to create.  The value you pass must be between the minimum and maximum sequence lengths the signal generator allows.  You can obtain the minimum and maximum sequence lengths from the minimumSequenceLength and maximumSequenceLength parameters in niFgen_QueryArbSeqCapabilities.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Waveform_Handles_Array">
        /// Pass the array of waveform handles from which you want to create a new arbitrary sequence.  The array must have at least as many elements as the value you specify in the sequenceLength parameter. Each waveformHandlesArray element has a corresponding loopCountsArray element that indicates how many times that waveform is repeated.  You obtain waveform handles when you create arbitrary waveforms with one of the niFgen Create Waveform functions or with niFgen_AllocateWaveform.
        /// 
        /// The niFgen Create Waveform functions are as follows:
        /// - niFgen_CreateWaveformF64
        /// - niFgen_CreateWaveformI16
        /// - niFgen_CreateWaveformFromFileI16
        /// - niFgen_CreateWaveformFromFileF64
        /// - niFgen_CreateWaveformFromFileHWS
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Loop_Counts_Array">
        /// Pass the array of loop counts that you want to use to create a new arbitrary sequence.  The array must have at least as many elements as the value you specify in the sequenceLength parameter.  Each loopCountsArray element corresponds to a waveformHandlesArray element and indicates how many times to repeat that waveform.  Each element of the loopCountArray must be less than or equal to the maximum number of loop counts the signal generator allows.  You can obtain the maximum loop count from the maximumLoopCount parameter of niFgen_QueryArbSeqCapabilities.
        /// 
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Sample_Counts_Array">
        /// Pass the array of sample counts that you want to use to create a new arbitrary sequence.  The array must have at least as many elements as the value you specify in the sequenceLength parameter.  Each sampleCountsArray element corresponds to a waveformHandlesArray element and indicates how many samples of the given waveform to generate.  Each element of the sampleCountArray must be larger than the minimum waveform size and a multiple of the waveform quantum.  You can obtain these values by calling niFgen_QueryArbWfmCapabilities.  
        /// 
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Marker_Location_Array">
        /// Pass the array of marker locations to where you want a marker to be generated in the sequence.  The array must have at least as many elements as the value you specify in the sequenceLength parameter.  Each markerLocationArray element corresponds to a waveformHandlesArray element and indicates where in the waveform a marker is to generate.  The marker location must be less than the size of the waveform the marker is in.  The markers are coerced to the nearest marker quantum and the coereced values are returned in the coercedMarkersArray parameter.  
        /// 
        /// If you do not want a marker generated for a particular sequence stage, set the marker to NIFGEN_VAL_NO_MARKER.
        /// 
        /// Defined Values: NIFGEN_VAL_NO_MARKER
        /// 
        /// Default Value: None
        /// </param>
        /// <param name="Coerced_Markers_Array">
        /// Returns an array of all given markers that are coerced (rounded) to the nearest marker quantum. Not all devices coerce markers.
        ///  
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Sequence_Handle">
        /// Returns the handle that identifies the new arbitrary sequence.  You pass this handle to niFgen_ConfigureArbSequence to generate the arbitrary sequence.
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status    Description
        /// -------------------------------------------------
        /// ERRORS
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
        /// 
        /// 
        /// </returns>
        public int CreateAdvancedArbSequence(int Sequence_Length, long[] Waveform_Handles_Array, long[] Loop_Counts_Array, long[] Sample_Counts_Array, long[] Marker_Location_Array, long[] Coerced_Markers_Array, out int Sequence_Handle)
        {
            int pInvokeResult = PInvoke.CreateAdvancedArbSequence(this._handle, Sequence_Length, Waveform_Handles_Array, Loop_Counts_Array, Sample_Counts_Array, Marker_Location_Array, Coerced_Markers_Array, out Sequence_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the signal generator attributes that affect arbitrary sequence generation. These attributes are the arbitrary sequence handle, gain, and offset.
        /// 
        /// Notes:
        /// 
        /// (1) The signal generator must not be in the Generating state when you call this function.
        /// 
        /// (2) You must set the output mode to NIFGEN_VAL_OUTPUT_SEQ before calling this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to configure an arbitrary sequence.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <param name="Sequence_Handle">
        /// Pass the handle of the arbitrary sequence that you want the signal generator to produce. NI-FGEN sets NIFGEN_ATTR_ARB_SEQUENCE_HANDLE to this value. You can create an arbitrary sequence using niFgen_CreateArbSequence. niFgen_CreateArbSequence returns a handle that you use to identify the sequence.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Gain">
        /// Specifies the factor by which the signal generator scales the arbitrary waveforms in the sequence. When you create arbitrary waveforms, you must first normalize the data points to a range of -1.00 to +1.00. You can use this parameter to scale the waveforms in the sequence to other ranges. NI-FGEN sets NIFGEN_ATTR_ARB_GAIN to this value.
        /// 
        /// For example, to configure the output signal to range from -2.00 V to +2.00 V, set the gain to 2.00.
        /// 
        /// Units: Volts
        /// 
        /// Default Value: None
        /// </param>
        /// <param name="Offset">
        /// Specifies the value the signal generator adds to the arbitrary waveforms in the sequence. When you create arbitrary waveforms, you must first normalize the data points to a range of -1.00 to +1.00. You can use this parameter to shift the ranges of the arbitrary waveforms in the sequence. NI-FGEN sets NIFGEN_ATTR_ARB_OFFSET to this value.
        /// 
        /// For example, to configure the output signal to range from 0.00 V to 2.00 V instead of -1.00 V to 1.00 V, set offset to 1.00.
        /// 
        /// Units: Volts
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list defines the ranges of additional status codes that NI-FGEN can return .
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureArbSequence(string Channel_Name, int Sequence_Handle, System.Double Gain, System.Double Offset)
        {
            int pInvokeResult = PInvoke.ConfigureArbSequence(this._handle, Channel_Name, Sequence_Handle, Gain, Offset);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Removes a previously created arbitrary sequence from the signal generator memory and invalidates the sequence handle.
        /// 
        /// Note:  The signal generator must not be in the Generating state when you call this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Sequence_Handle">
        /// Pass the handle of the arbitrary sequence you want the signal generator to remove. You can create multiple arbitrary sequences using niFgen_CreateArbSequence. niFgen_CreateArbSequence returns a handle that you use to identify each sequence.
        /// 
        /// Defined Value
        /// 
        /// NIFGEN_VAL_ALL_SEQUENCES - Remove all sequences from the signal generator
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list defines the ranges of additional status codes that NI-FGEN can return with the different include files that contain the defined constants for the particular status codes.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ClearArbSequence(int Sequence_Handle)
        {
            int pInvokeResult = PInvoke.ClearArbSequence(this._handle, Sequence_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Removes all previously created arbitrary waveforms and sequences from the signal generator memory, and invalidates all waveform and sequence handles.
        /// 
        /// Note:  The signal generator must not be in the Generating state when you call this function.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Include       Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list defines the ranges of additional status codes that NI-FGEN can return with the different include files that contain the defined constants for the particular status codes.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ClearArbMemory()
        {
            int pInvokeResult = PInvoke.ClearArbMemory(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Specifies the size of a waveform up-front so that it can be allocated in onboard memory before loading the associated data.  Data can then be loaded in smaller chunks with the Write(Binary16)Waveform functions.  
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to allocate the waveform.
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Waveform_Size">
        /// Specifies the size of the waveform to allocate in samples.
        /// </param>
        /// <param name="Waveform_Handle">
        /// Return Value: The handle that identifies the waveform.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status    Description
        /// -------------------------------------------------
        /// ERRORS
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
        /// </returns>
        public int AllocateWaveform(string Channel_Name, int Waveform_Size, out int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.AllocateWaveform(this._handle, Channel_Name, Waveform_Size, out Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Sets the position in the waveform to which data is written at the next write. This function allows you to write to arbitrary locations within the waveform. These settings apply only to the next write to the waveform specified by the waveformHandle parameter. Subsequent writes to that waveform begin where the last write left off, unless this function is called again. The waveformHandle passed in must have been created with a call to one of the following functions:
        /// - niFgen_AllocateWaveform
        /// - niFgen_CreateWaveformF64
        /// - niFgen_CreateWaveformI16
        /// - niFgen_CreateWaveformFromFileI16
        /// - niFgen_CreateWaveformFromFileF64
        /// - niFgen_CreateWaveformFromFileHWS
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// The channel on which to the waveform data should be loaded.
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Waveform_Handle">
        /// Specifies the handle of the arbitrary waveform previously allocated with niFgen_AllocateWaveform.
        /// </param>
        /// <param name="relativeTo">
        /// Specifies the reference position in the waveform. The position and offset together determine where to start loading data into the waveform.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_WAVEFORM_POSITION_START   0
        /// NIFGEN_VAL_WAVEFORM_POSITION_CURRENT 1
        /// </param>
        /// <param name="offset">
        /// Specifies the offset from the relativeTo parameter at which to start loading the data into the waveform. 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// </returns>
        public int SetWaveformNextWritePosition(string Channel_Name, int Waveform_Handle, int relativeTo, int offset)
        {
            int pInvokeResult = PInvoke.SetWaveformNextWritePosition(this._handle, Channel_Name, Waveform_Handle, relativeTo, offset);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Writes floating-point data to the waveform in onboard memory.  The waveform handle passed in must have been created by a call to niFgen_AllocateWaveform or to one of the niFgen Create Waveform functions. 
        /// 
        /// The niFgen Create Waveform functions are as follows:
        /// 
        /// - niFgen_CreateWaveformF64
        /// - niFgen_CreateWaveformI16
        /// - niFgen_CreateWaveformFromFileI16
        /// - niFgen_CreateWaveformFromFileF64
        /// - niFgen_CreateWaveformFromFileHWS
        /// 
        /// The write position and offset can be set by calling niFgen_SetWaveformNextWritePosition.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// The channel on which to the waveform data should be loaded.
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Waveform_Handle">
        /// Specifies the handle of the arbitrary waveform previously allocated with niFgen_AllocateWaveform. 
        /// </param>
        /// <param name="Size">
        /// Specifies the number of samples to load into the waveform.
        /// 
        /// Default Value: 0
        /// </param>
        /// <param name="Data">
        /// Specifies the array of data to load into the waveform. The array must have at least as many elements as the value in the Size parameter.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// </returns>
        public int WriteWaveform(string Channel_Name, int Waveform_Handle, int Size, System.Double[] Data)
        {
            int pInvokeResult = PInvoke.WriteWaveform(this._handle, Channel_Name, Waveform_Handle, Size, Data);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Writes complex data to the waveform in onboard memory on devices with the NIFGEN_ATTR_OUTPUT_ENABLED attribute set to VI_TRUE and the NIFGEN_ATTR_OSP_DATA_PROCESSING_MODE attribute set to NIFGEN_VAL_OSP_COMPLEX. The waveform handle passed in must have been created by a call to niFgen_AllocateWaveform or to one of the niFgen Create Waveform functions. 
        /// 
        /// The niFgen Create Waveform functions are as follows:
        /// 
        /// - niFgen_CreateWaveformF64
        /// - niFgen_CreateWaveformI16
        /// - niFgen_CreateWaveformFromFileI16
        /// - niFgen_CreateWaveformFromFileF64
        /// - niFgen_CreateWaveformFromFileHWS
        /// 
        /// The write position and offset can be set by calling niFgen_SetWaveformNextWritePosition.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// The channel on which to the waveform data should be loaded.
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Number_of_Samples">
        /// Specifies the number of samples to load into the waveform.
        /// 
        /// Default Value: 0
        /// </param>
        /// <param name="Data">
        /// Specifies the array of data to load into the waveform. You must normalize the data points in the array to be between -1.00 and +1.00. The array must have at least as many elements as the value in the Number of Samples parameter.
        /// </param>
        /// <param name="Waveform_Handle">
        /// Specifies the handle of the arbitrary waveform previously allocated with niFgen_AllocateWaveform. 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// </returns>
        public int WriteWaveformComplexF64(string Channel_Name, int Number_of_Samples, niFgenComplexF64[] Data, int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.WriteWaveformComplexF64(this._handle, Channel_Name, Number_of_Samples, Data, Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Writes binary data to the waveform in onboard memory. The waveform handle passed in must have been created by a call to niFgen_AllocateWaveform or niFgen_CreateWaveformI16.
        /// 
        /// The write position and offset can be set by calling niFgen_SetWaveformNextWritePosition.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// The channel on which to the waveform data should be loaded.
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Waveform_Handle">
        /// Specifies the handle of the arbitrary waveform previously allocated with niFgen_AllocateWaveform. 
        /// </param>
        /// <param name="Size">
        /// Specifies the number of samples to load into the waveform.
        /// 
        /// Default Value: 0
        /// </param>
        /// <param name="Data">
        /// Specifies the array of data to load into the waveform. The array must have at least as many elements as the value in the size parameter. The binary data is left-justified.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// </returns>
        public int WriteBinary16Waveform(string Channel_Name, int Waveform_Handle, int Size, short[] Data)
        {
            int pInvokeResult = PInvoke.WriteBinary16Waveform(this._handle, Channel_Name, Waveform_Handle, Size, Data);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the signal generator reference clock source. The signal generator uses the reference clock to derive frequencies and sample rates when generating waveforms.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Reference_Clock_Source">
        /// Pass the reference clock source that you want the signal generator to use. NI-FGEN sets NIFGEN_ATTR_REF_CLOCK_SOURCE to this value.
        /// 
        /// The signal generator derives the frequencies and sample rates that it uses to generate waveforms from the source you specify.
        /// 
        /// For example, when you set this parameter to NIFGEN_VAL_REF_CLOCK_EXTERNAL, the signal generator uses the signal it receives at its external clock terminal as the reference clock.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_REF_CLOCK_INTERNAL   - Internal clock source
        /// NIFGEN_VAL_REF_CLOCK_EXTERNAL   - External clock source
        /// NIFGEN_VAL_REF_CLOCK_RTSI_CLOCK - RTSI clock
        /// NIFGEN_VAL_REF_CLOCK_TTL7       - TTL 7 line
        /// NIFGEN_VAL_PXI_CLK10            - PXI 10 MHz clock
        /// NIFGEN_VAL_REF_IN               - External clock source
        /// NIFGEN_VAL_RTSI_0               - RTSI 0 or PXI_Trig 0
        /// NIFGEN_VAL_RTSI_1               - RTSI 1 or PXI_Trig 1
        /// NIFGEN_VAL_RTSI_2               - RTSI 2 or PXI_Trig 2
        /// NIFGEN_VAL_RTSI_3               - RTSI 3 or PXI_Trig 3
        /// NIFGEN_VAL_RTSI_4               - RTSI 4 or PXI_Trig 4
        /// NIFGEN_VAL_RTSI_5               - RTSI 5 or PXI_Trig 5
        /// NIFGEN_VAL_RTSI_6               - RTSI 6 or PXI_Trig 6
        /// NIFGEN_VAL_RTSI_7               - RTSI 7 or PXI_Trig 7
        /// NIFGEN_VAL_CLK_IN               - CLK IN front panel connector
        /// 
        /// Default Value: NIFGEN_VAL_REF_CLOCK_INTERNAL
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureRefClockSource(int Reference_Clock_Source)
        {
            int pInvokeResult = PInvoke.ConfigureRefClockSource(this._handle, Reference_Clock_Source);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the signal generator reference clock frequency.  The signal generator uses the reference clock to derive frequencies and sample rates when generating waveforms.
        /// 
        /// Note:  The signal generator must not be in the Generating state when you call this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Reference_Clock_Frequency">
        /// The reference clock frequency in hertz.
        /// 
        /// Default Value: 10000000
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status    Description
        /// -------------------------------------------------
        /// ERRORS
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureRefClockFrequency(System.Double Reference_Clock_Frequency)
        {
            int pInvokeResult = PInvoke.ConfigureRefClockFrequency(this._handle, Reference_Clock_Frequency);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Selects the clock mode for the signal generator.  
        /// 
        /// For signal generators that support it, this function allows you to switch the sample clock to High-Resolution Sampling mode. 
        /// 
        /// When in Divide-Down Sampling mode, you can only set the sample rate to certain frequences, based on dividing down the update clock. However, in High-Resolution Sampling mode, you can set the sample rate to any value.  
        /// 
        /// Notes:
        /// 
        /// (1) The signal generator must not be in the Generating state when you call this function.
        /// 
        /// (2) You must set the output mode to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Clock_Mode">
        /// Sets the clock mode of the signal generator. 
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_DIVIDE_DOWN
        /// NIFGEN_VAL_HIGH_RESOLUTION
        /// NIFGEN_VAL_AUTOMATIC
        /// 
        /// Default value: Depends on the device.
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return .
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureClockMode(int Clock_Mode)
        {
            int pInvokeResult = PInvoke.ConfigureClockMode(this._handle, Clock_Mode);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Sets the source of the update clock of the signal generator.  The source can be internal or external.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Update_Clock_Source">
        /// Controls the update clock source.
        /// 
        /// Defined Values
        ///   
        /// NIFGEN_VAL_INTERNAL   - Internal clock source
        /// NIFGEN_VAL_EXTERNAL   - External clock source
        /// NIFGEN_VAL_PXI_STAR   - PXI Star
        /// NIFGEN_VAL_RTSI_0     - RTSI 0 or PXI_Trig 0
        /// NIFGEN_VAL_RTSI_1     - RTSI 1 or PXI_Trig 1
        /// NIFGEN_VAL_RTSI_2     - RTSI 2 or PXI_Trig 2
        /// NIFGEN_VAL_RTSI_3     - RTSI 3 or PXI_Trig 3
        /// NIFGEN_VAL_RTSI_4     - RTSI 4 or PXI_Trig 4
        /// NIFGEN_VAL_RTSI_5     - RTSI 5 or PXI_Trig 5
        /// NIFGEN_VAL_RTSI_6     - RTSI 6 or PXI_Trig 6
        /// NIFGEN_VAL_RTSI_7     - RTSI 7 or PXI_Trig 7
        /// NIFGEN_VAL_CLK_IN     - CLK IN front panel connector
        /// NIFGEN_VAL_DDC_CLK_IN - Digital Data &amp; Control clock in
        /// 
        /// Default Value: NIFGEN_VAL_INTERNAL
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureUpdateClockSource(int Update_Clock_Source)
        {
            int pInvokeResult = PInvoke.ConfigureUpdateClockSource(this._handle, Update_Clock_Source);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Delays (or phase shifts) the sample clock, which delays the output of the module.  Delaying the sample clock can be useful when lining up the output of multiple modules or when intentionally phase shifting the output relative to a fixed reference such as the PLL reference clock.  
        /// 
        /// Adjustment time can be positive or negative, but it must be less than or equal to the sample clock period.  The delay takes effect immediately after this function is called.  To delay an external sample clock, use NIFGEN_ATTR_SAMPLE_CLOCK_ABSOLUTE_DELAY.
        /// 
        /// Note:  Calling this function after calling NI-TClk Synchronize may cause synchronization to become undone.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Adjustment_Time">
        /// The amount of time to adjust the sample clock delay in seconds.
        /// 
        /// Default Value: 0
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status    Description
        /// -------------------------------------------------
        /// ERRORS
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
        /// 
        /// 
        /// </returns>
        public int AdjustSampleClockRelativeDelay(System.Double Adjustment_Time)
        {
            int pInvokeResult = PInvoke.AdjustSampleClockRelativeDelay(this._handle, Adjustment_Time);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the trigger source. The signal generator responds to a trigger depending on the operation mode in which the signal generator is operating.
        /// 
        /// Note: The signal generator must not be in the Generating state when you call this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to configure the trigger source.
        /// 
        /// Defined Channel Name
        /// 
        /// 0
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <param name="Trigger_Source">
        /// Controls which trigger source the signal generator uses.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_IMMEDIATE     - Immediate
        /// NIFGEN_VAL_EXTERNAL      - External (maps to PFI 0)
        /// NIFGEN_VAL_SOFTWARE_TRIG - Software trigger
        /// NIFGEN_VAL_PXI_STAR      - PXI Star
        /// NIFGEN_VAL_RTSI_0        - RTSI 0 or PXI_Trig 0
        /// NIFGEN_VAL_RTSI_1        - RTSI 1 or PXI_Trig 1
        /// NIFGEN_VAL_RTSI_2        - RTSI 2 or PXI_Trig 2
        /// NIFGEN_VAL_RTSI_3        - RTSI 3 or PXI_Trig 3
        /// NIFGEN_VAL_RTSI_4        - RTSI 4 or PXI_Trig 4
        /// NIFGEN_VAL_RTSI_5        - RTSI 5 or PXI_Trig 5
        /// NIFGEN_VAL_RTSI_6        - RTSI 6 or PXI_Trig 6
        /// NIFGEN_VAL_RTSI_7        - RTSI 7 or PXI_Trig 7
        /// NIFGEN_VAL_TTL0          - TTL 0
        /// NIFGEN_VAL_TTL1          - TTL 1
        /// NIFGEN_VAL_TTL2          - TTL 2
        /// NIFGEN_VAL_TTL3          - TTL 3
        /// NIFGEN_VAL_TTL4          - TTL 4
        /// NIFGEN_VAL_TTL5          - TTL 5
        /// NIFGEN_VAL_TTL6          - TTL 6
        /// NIFGEN_VAL_PFI_0         - PFI 0
        /// NIFGEN_VAL_PFI_1         - PFI 1
        /// NIFGEN_VAL_PFI_2         - PFI 2
        /// NIFGEN_VAL_PFI_3         - PFI 3
        /// 
        /// Default Value: Immediate
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureTriggerSource(string Channel_Name, int Trigger_Source)
        {
            int pInvokeResult = PInvoke.ConfigureTriggerSource(this._handle, Channel_Name, Trigger_Source);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Sets the trigger mode.
        /// 
        /// Supported trigger modes are:
        /// 
        /// Single Trigger mode - The waveform that you describe in the sequence list generates only once by going through the entire staging list. Only one trigger is required to start the waveform generation. You can use single trigger mode with the output mode in any mode.  After a trigger is received, the waveform generation starts from the first stage and continues through to the last stage. 
        /// 
        /// Continuous Trigger mode - The waveform that you describe in the staging list generates infinitely by repeatedly cycling through the staging list. After a trigger is received, the waveform generation starts from the first stage and continues through to the last stage. After the last stage is completed, the waveform generation loops back to the start of the first stage and continues until it is stopped. Only one trigger is required to start the waveform generation.
        /// 
        /// Stepped Trigger mode - After a start trigger is received, the waveform described by the first stage generates. Then, the device waits for the next trigger signal. On the next trigger, the waveform described by the second stage generates, and so on. Once the staging list is exhausted, the waveform generation returns to the first stage and continues to repeat the cycle.  
        /// 
        /// Burst Trigger mode - After a start trigger is received, the waveform described by the first stage generates until another trigger is received. At the next trigger, the buffer of the previous stage completes, and then the waveform described by the second stage generates. Once the staging list is exhausted, the waveform generation returns to the first stage and continues to repeat the cycle.  In Frequency List mode, the duration instruction is ignored, and the trigger switches the frequency to the next frequency in the list.
        /// 
        /// Note:  In Frequency List mode, Stepped Trigger mode is the same as Burst Trigger mode.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to configure the trigger mode.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <param name="Trigger_Mode">
        /// This sets the trigger mode.
        /// 
        /// Defined Values:
        /// 
        /// NIFGEN_VAL_SINGLE - Single Trigger mode
        /// NIFGEN_VAL_CONTINUOUS - Continuous Trigger mode
        /// NIFGEN_VAL_STEPPED - Stepped Trigger mode
        /// NIFGEN_VAL_BURST - Burst Trigger mode
        /// 
        /// Default Value: NIFGEN_VAL_CONTINUOUS
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status    Description
        /// -------------------------------------------------
        /// ERRORS
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureTriggerMode(string Channel_Name, int Trigger_Mode)
        {
            int pInvokeResult = PInvoke.ConfigureTriggerMode(this._handle, Channel_Name, Trigger_Mode);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Routes various signals in the signal generator to the RTSI lines and front panel terminals.  
        /// 
        /// Notes:
        /// 
        /// (1) The signal generator must not be in the Generating state when you call this function.
        /// 
        /// (2) You can clear a previously routed signal by routing NIFGEN_VAL_NONE to the destination terminal.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to route a signal.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <param name="Route_Signal_From">
        /// Specifies the source of the signal to route. 
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_NONE - Route nothing to the RTSI line. Clears the line.
        ///  
        /// NIFGEN_VAL_MARKER - The marker as specified by the markers parameter in niFgen_CreateAdvancedArbSequence.
        /// 
        /// NIFGEN_VAL_SYNC_OUT - The SYNC signal that normally appears on the SYNC_OUT front panel connector.
        /// 
        /// NIFGEN_VAL_OUT_START_TRIGGER - The trigger generated at the start of the sequence. Call niFgen_ConfigureTriggerSource to receive this trigger.
        /// 
        /// NIFGEN_VAL_BOARD_CLOCK - NIFGEN_VAL_BOARD_CLOCK The signal generator board clock, which is 20 MHz for the NI PCI-5401/5411/5431.  The NI PXI-5404 has a 20 MHz board clock, and the NI PXI-5421 has integer divisors of 100 MHz.  The NI PXI-5401/5411/5431 does not support routing a Board Clock out.
        /// 
        /// NIFGEN_VAL_SYNCHRONIZATION - A synchronization strobe used to guarantee absolute synchronization between two or more signal generators. Call niFgen_ConfigureSynchronization to receive the strobe. 
        /// 
        /// NIFGEN_VAL_SOFTWARE_TRIG - Software trigger
        /// MIFGEN_VAL_OUT_UPDATE
        /// NIFGEN_VAL_REF_OUT - Reference clock out
        /// NIFGEN_VAL_PXI_CLK10 - PXI 10 MHz clock 
        /// NIFGEN_VAL_PXI_STAR - PXI Star
        /// NIFGEN_VAL_PFI_0 - PFI 0
        /// NIFGEN_VAL_RTSI_0 - RTSI 0 or PXI_Trig 0
        /// NIFGEN_VAL_RTSI_1 - RTSI 1 or PXI_Trig 1
        /// NIFGEN_VAL_RTSI_2 - RTSI 2 or PXI_Trig 2
        /// NIFGEN_VAL_RTSI_3 - RTSI 3 or PXI_Trig 3
        /// NIFGEN_VAL_RTSI_4 - RTSI 4 or PXI_Trig 4
        /// NIFGEN_VAL_RTSI_5 - RTSI 5 or PXI_Trig 5
        /// NIFGEN_VAL_RTSI_6 - RTSI 6 or PXI_Trig 6
        /// NIFGEN_VAL_RTSI_7 - RTSI 7 or PXI_Trig 7
        /// NIFGEN_VAL_REF_CLOCK_RTSI_CLOCK - RTSI Clock
        /// NIFGEN_VAL_CLOCK_OUT - Clock Out
        /// NIFGEN_VAL_UPDATE_CLOCK - Sample Clock
        /// NIFGEN_VAL_PLL_REF_SOURCE - PLL Reference Clock
        /// </param>
        /// <param name="Route_Signal_To">
        /// Specifies the destination of the signal to route.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_RTSI_0 - RTSI 0 or PXI_Trig 0
        /// NIFGEN_VAL_RTSI_1 - RTSI 1 or PXI_Trig 1
        /// NIFGEN_VAL_RTSI_2 - RTSI 2 or PXI_Trig 2
        /// NIFGEN_VAL_RTSI_3 - RTSI 3 or PXI_Trig 3
        /// NIFGEN_VAL_RTSI_4 - RTSI 4 or PXI_Trig 4
        /// NIFGEN_VAL_RTSI_5 - RTSI 5 or PXI_Trig 5
        /// NIFGEN_VAL_RTSI_6 - RTSI 6 or PXI_Trig 6
        /// NIFGEN_VAL_RTSI_CLOCK - RTSI clock
        /// NIFGEN_VAL_REF_OUT - Reference clock out
        /// NIFGEN_VAL_PFI_0 - PFI 0
        /// NIFGEN_VAL_PFI_1 - PFI 1
        /// NIFGEN_VAL_PFI_4 - PFI 4
        /// NIFGEN_VAL_PFI_5 - PFI 5
        /// NIFGEN_VAL_PXI_STAR - PXI Star
        /// NIFGEN_VAL_PXI_CLK10 - PXI 10 MHz clock
        /// NIFGEN_VAL_DDC_CLK_OUT - Digital and Data Control front panel connector
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int RouteSignalOut(string Channel_Name, int Route_Signal_From, int Route_Signal_To)
        {
            int pInvokeResult = PInvoke.RouteSignalOut(this._handle, Channel_Name, Route_Signal_From, Route_Signal_To);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Sets the signal generator to receive a synchronization signal to synchronize two or more NI 5401/5411/5431 signal generators. One signal generator should send a signal to a RTSI line by calling niFgen_RouteSignalOut, and other signal generators should receive the signal by calling niFgen_ConfigureSynchronization.
        /// 
        /// Note:  The signal generator must not be in the Generating state when you call this function.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to configure the synchronization signal.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <param name="Synchronization_Source">
        /// Specify the source of the synchronization signal you want to use.  
        /// 
        /// Defined Values:
        /// 
        /// NIFGEN_VAL_NONE         - No synchronization source
        /// NIFGEN_VAL_RTSI_0       - RTSI 0 or PXI_Trig 0
        /// NIFGEN_VAL_RTSI_1       - RTSI 1 or PXI_Trig 1
        /// NIFGEN_VAL_RTSI_2       - RTSI 2 or PXI_Trig 2
        /// NIFGEN_VAL_RTSI_3       - RTSI 3 or PXI_Trig 3
        /// NIFGEN_VAL_RTSI_4       - RTSI 4 or PXI_Trig 4
        /// NIFGEN_VAL_RTSI_5       - RTSI 5 or PXI_Trig 5
        /// NIFGEN_VAL_RTSI_6       - RTSI 6 or PXI_Trig 6
        /// NIFGEN_VAL_TTL0         - TTL 0
        /// NIFGEN_VAL_TTL1         - TTL 1
        /// NIFGEN_VAL_TTL2         - TTL 2
        /// NIFGEN_VAL_TTL3         - TTL 3
        /// NIFGEN_VAL_TTL4         - TTL 4
        /// NIFGEN_VAL_TTL5         - TTL 5
        /// NIFGEN_VAL_TTL6         - TTL 6
        /// 
        /// Default Value:
        /// 
        /// NIFGEN_VAL_NONE
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status    Description
        /// -------------------------------------------------
        /// ERRORS
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureSynchronization(string Channel_Name, int Synchronization_Source)
        {
            int pInvokeResult = PInvoke.ConfigureSynchronization(this._handle, Channel_Name, Synchronization_Source);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Sets the FIR filter coefficients used by the onboard signal processing block. The values are coerced to the closest settings achieveable by the signal generator.
        /// 
        /// Refer to Devices&gt;&gt;NI 5441&gt;&gt;Theory of Operation&gt;&gt;Onboard Signal Processing&gt;&gt;Components&gt;&gt;FIR Filter in the NI Signal Generators Help for more information about FIR filter coefficients.
        /// 
        /// Note 
        /// The signal generator must not be in the Generating state when you call this function.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to configure the operation mode.
        /// 
        /// Defined Value
        /// 
        /// 0
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Number_of_Coefficients">
        /// Specify the number of coefficients. The NI 5441 requires 95.
        /// 
        /// </param>
        /// <param name="Coefficients_Array">
        /// Specifies the array of data the onboard signal processor uses for the FIR filter coefficients. For the NI 5441, you must provide a symmetric array of 95 coefficients to this parameter. The array must have at least as many elements as the value that you specify in the Number of Coefficients parameter.
        /// 
        /// The coefficients should range between -1.00 and +1.00.
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int ConfigureCustomFIRFilterCoefficients(string Channel_Name, int Number_of_Coefficients, System.Double[] Coefficients_Array)
        {
            int pInvokeResult = PInvoke.ConfigureCustomFIRFilterCoefficients(this._handle, Channel_Name, Number_of_Coefficients, Coefficients_Array);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the FIR filter coefficients used by the onboard signal processing block. These coefficients are determined by NI-FGEN and based on the FIR filter type and corresponding attribute (Alpha, Passband, BT) unless you are using the custom filter. If you are using a custom filter, the coefficients returned are those set with the niFgen_ConfigureCustomFIRFilterCoefficients  function coerced to the quantized values used by the device.
        /// 
        /// The coefficients will be in the range between -1.00 and +1.00.
        /// 
        /// Refer to Devices&gt;&gt;NI 5441&gt;&gt;Theory of Operation&gt;&gt;Onboard Signal Processing&gt;&gt;Components&gt;&gt;FIR Filter in the NI Signal Generators Help for more information about FIR filter coefficients.
        /// 
        /// Default Value: None
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to configure the operation mode.
        /// 
        /// Defined Value
        /// 
        /// 0
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Array_Size">
        /// Pass the size of the coefficient array
        /// </param>
        /// <param name="Coefficients_Array">
        /// Specify the array of data that you want to use for the coefficients. The array must have at least as many elements as the value that you specify in the Array Size parameter.
        /// 
        /// The coefficients should be in the range between -1.00 and +1.00
        /// 
        /// Default Value: None
        /// </param>
        /// <param name="Number_of_Coefficients_Read">
        /// Specify the array of data containing the number of coefficients you want to read.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int GetFIRFilterCoefficients(string Channel_Name, int Array_Size, System.Double[] Coefficients_Array, long[] Number_of_Coefficients_Read)
        {
            int pInvokeResult = PInvoke.GetFIRFilterCoefficients(this._handle, Channel_Name, Array_Size, Coefficients_Array, Number_of_Coefficients_Read);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Initiates signal generation.  If you want to abort signal output, call niFgen_AbortGeneration. Call this function to cause the signal generator to produces a signal again.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status    Description
        /// -------------------------------------------------
        /// ERRORS
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
        /// 
        /// 
        /// </returns>
        public int InitiateGeneration()
        {
            int pInvokeResult = PInvoke.InitiateGeneration(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Aborts any previously initiated signal generation. If you want to abort signal generation, call this function. Call  niFgen_InitiateGeneration to cause the signal generator to produce a signal again.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status    Description
        /// -------------------------------------------------
        /// ERRORS
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
        /// 
        /// 
        /// </returns>
        public int AbortGeneration()
        {
            int pInvokeResult = PInvoke.AbortGeneration(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Sends a command to trigger the signal generator. 
        /// 
        /// Note:
        /// 
        /// This function can act as an override for an external edge trigger. However, the NI&amp;nbsp;5401/5411/5431 
        /// do not support overriding an external digital edge trigger.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int SendSoftwareTrigger()
        {
            int pInvokeResult = PInvoke.SendSoftwareTrigger(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the current hardware state of the device and, if the device is in the hardware error state, the current hardware error.  
        /// 
        /// NOTE:  Hardware states do not necessarily correspond to NI-FGEN states.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_IDLE:    The device is in the idle state.
        /// NIFGEN_VAL_WAITING_FOR_START_TRIGGER: The device is waiting for   
        ///                                       start trigger.
        /// NIFGEN_VAL_RUNNING: The device is in the running state.
        /// NIFGEN_VAL_DONE:    The generation has completed successfully.
        /// NIFGEN_VAL_HARDWARE_ERROR: There is a hardware error.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="state">
        /// Defined Values
        /// 
        /// NIFGEN_VAL_IDLE:    The device is in the idle state.
        /// NIFGEN_VAL_WAITING_FOR_START_TRIGGER: The device is waiting for   
        ///                                       start trigger.
        /// NIFGEN_VAL_RUNNING: The device is in the running state.
        /// NIFGEN_VAL_DONE:    The generation has completed successfully.
        /// NIFGEN_VAL_HARDWARE_ERROR: There is a hardware error.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status    Description
        /// -------------------------------------------------
        /// ERRORS
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
        /// </returns>
        public int GetHardwareState(out int state)
        {
            int pInvokeResult = PInvoke.GetHardwareState(this._handle, out state);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Waits until the device is done generating or until the maximum time has expired.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="maxTime">
        /// The timeout value (in milliseconds).
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// </returns>
        public int WaitUntilDone(int maxTime)
        {
            int pInvokeResult = PInvoke.WaitUntilDone(this._handle, maxTime);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Determines whether the the current generation has completed.  This function sets the done parameter to be true if the session is in the Idle or Committed states.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Done">
        /// True if the generation has completed, false otherwise.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status    Description
        /// -------------------------------------------------
        /// ERRORS
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
        /// </returns>
        public int IsDone(out bool Done)
        {
            System.UInt16 DoneAsUShort;
            int pInvokeResult = PInvoke.IsDone(this._handle, out DoneAsUShort);
            Done = System.Convert.ToBoolean(DoneAsUShort);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Resets the instrument and applies initial user specified settings from the logical name that was used to initialize the session.  If the session was created without a logical name, this function is equivalent to niFgen_reset.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use the niFgen_GetError and niFgen_ClearError functions.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int ResetWithDefaults()
        {
            int pInvokeResult = PInvoke.ResetWithDefaults(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Performs a hard reset on the device.  Generation is stopped, all routes are released, external bi-directional terminals are tri-stated, FPGAs are reset, hardware is configured to its default state, and all session attributes are reset to their default states.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status    Description
        /// -------------------------------------------------
        /// ERRORS
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
        /// 
        /// 
        /// </returns>
        public int ResetDevice()
        {
            int pInvokeResult = PInvoke.ResetDevice(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// The function returns the channel string that is in the channel table at an index you specify.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Index">
        /// A 1-based index into the channel table.
        /// 
        /// </param>
        /// <param name="BufferSize">
        /// Size of the buffer for the channel string
        /// </param>
        /// <param name="Channel_Name">
        /// Returns the channel string that is in the channel table at the index you specify.
        /// 
        /// Do not modify the contents of the channel string.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use the niFgen_GetError and niFgen_ClearError functions.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int GetChannelName(int Index, int BufferSize, System.Text.StringBuilder Channel_Name)
        {
            int pInvokeResult = PInvoke.GetChannelName(this._handle, Index, BufferSize, Channel_Name);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Places the instrument in a quiescent state where it has minimal or no impact on the system to which it is connected.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use the niFgen_GetError and niFgen_ClearError functions.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int Disable()
        {
            int pInvokeResult = PInvoke.Disable(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Runs the instrument self-test routine and returns the test result(s). 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Self_Test_Result">
        /// Contains the value returned from the instrument self-test.  Zero means success.  For any other code, refer to the Error and Status Information topic in the NI Signal Sources Help.
        /// 
        /// Self-Test Code    Description
        /// ---------------------------------------
        ///    0              Passed self-test
        ///    1              Self test failed
        /// 
        /// 
        /// </param>
        /// <param name="Self_Test_Message">
        /// Returns the self-test response string from the instrument. Refer to the Error and Status Information topic in the NI Signal Sources Help for an explanation of the string contents.
        /// 
        /// You must pass a ViChar array with at least 256 bytes.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status    Description
        /// -------------------------------------------------
        /// ERRORS
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
        /// 
        /// 
        /// </returns>
        public int self_test(out short Self_Test_Result, System.Text.StringBuilder Self_Test_Message)
        {
            int pInvokeResult = PInvoke.self_test(this._handle, out Self_Test_Result, Self_Test_Message);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the revision numbers of the NI-FGEN and instrument firmware.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Instrument_Driver_Revision">
        /// Returns the NI-FGEN software revision numbers in the form of a string.
        /// 
        /// You must pass a ViChar array with at least 256 bytes.
        /// </param>
        /// <param name="Firmware_Revision">
        /// Returns the instrument firmware revision numbers in the form of a string.
        /// 
        /// You must pass a ViChar array with at least 256 bytes.
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status    Description
        /// -------------------------------------------------
        /// ERRORS
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
        /// 
        /// 
        /// </returns>
        public int revision_query(System.Text.StringBuilder Instrument_Driver_Revision, System.Text.StringBuilder Firmware_Revision)
        {
            int pInvokeResult = PInvoke.revision_query(this._handle, Instrument_Driver_Revision, Firmware_Revision);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the coercion information associated with the IVI session.  This function retrieves and clears the oldest instance in which the NI-FGEN coerced a value you specified to another value.
        /// 
        /// If you set the NIFGEN_ATTR_RECORD_COERCIONS attribute to VI_TRUE, the NI-FGEN keeps a list of all coercions it makes on ViInt32 or ViReal64 values you pass to NI-FGEN functions.  You use this function to retrieve information from that list.
        /// 
        /// If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies bufferSize - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.  For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7.
        /// 
        /// If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
        /// 
        /// If you pass 0, you can pass VI_NULL for the coercionRecord buffer parameter.
        /// 
        /// The function returns an empty string in the coercionRecord parameter if no coercion records remain for the session.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// </param>
        /// <param name="Buffer_Size">
        /// Pass the number of bytes in the ViChar array you specify for the coercionRecord parameter.
        /// 
        /// If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies bufferSize - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size that you must pass to get the entire value.  For example, if the value is "123456" and the buffer size is 4, the function places "123" into the buffer and returns 7.
        /// 
        /// If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
        /// 
        /// If you pass 0, you can pass VI_NULL for the coercionRecord buffer parameter.
        /// 
        /// Default Value:  None
        /// 
        /// 
        /// </param>
        /// <param name="Coercion_Record">
        /// Returns the next coercion record for the IVI session.  If there are no coercion records, the function returns an empty string.
        /// 
        /// The buffer must contain at least as many elements as the value you specify with the bufferSize parameter.  If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate with the bufferSize parameter, the function copies bufferSize - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size that you must pass to get the entire value.  For example, if the value is "123456" and the buffer size is 4, the function places "123" into the buffer and returns 7.
        /// 
        /// This parameter returns an empty string if no coercion records remain for the session.
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// If the current value of the return buffer, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.  For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status    Description
        /// -------------------------------------------------
        /// ERRORS
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        ///         
        /// NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
        /// 
        /// 
        /// </returns>
        public int GetNextCoercionRecord(int Buffer_Size, System.Text.StringBuilder Coercion_Record)
        {
            int pInvokeResult = PInvoke.GetNextCoercionRecord(this._handle, Buffer_Size, Coercion_Record);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Reads an error code and a message from the instrument error queue.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Error_Code">
        /// Returns the error code read from the instrument error queue.
        /// 
        /// 
        /// </param>
        /// <param name="Error_Message">
        /// Returns the error message string read from the instrument error message queue.
        /// 
        /// You must pass a ViChar array with at least 256 bytes.
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status    Description
        /// -------------------------------------------------
        /// ERRORS
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        ///           
        /// NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
        /// 
        /// 
        /// </returns>
        public int error_query(out int Error_Code, System.Text.StringBuilder Error_Message)
        {
            int pInvokeResult = PInvoke.error_query(this._handle, out Error_Code, Error_Message);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Converts a status code returned by an NI-FGEN function into a user-readable string and returns any error elaborations.   
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// You can pass VI_NULL for this parameter.  Passing VI_NULL is useful when one of the initialize functions fail.
        /// 
        /// Default Value:  VI_NULL
        /// 
        /// </param>
        /// <param name="Error_Code">
        /// Pass the Status parameter that is returned from any of the NI-FGEN functions.
        /// 
        /// Default Value:  0  (VI_SUCCESS)
        /// </param>
        /// <param name="Error_Message">
        /// Returns the user-readable message string that corresponds to the status code you specify.
        /// 
        /// You must pass a ViChar array with at least 256 bytes.
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status    Description
        /// -------------------------------------------------
        /// ERRORS
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
        ///           
        /// Numeric Range (in Hex)   Include Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
        /// 
        /// 
        /// </returns>
        public int ErrorHandler(int Error_Code, System.Text.StringBuilder Error_Message)
        {
            int pInvokeResult = PInvoke.ErrorHandler(this._handle, Error_Code, Error_Message);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the interchangeability warnings associated with the IVI session. It retrieves and clears the oldest instance in which the class driver recorded an interchangeability warning.  Interchangeability warnings indicate that using your application with a different instrument might cause different behavior. Use this function to retrieve interchangeability warnings.
        /// 
        /// NI-FGEN performs interchangeability checking when NIFGEN_ATTR_INTERCHANGE_CHECK is set to VI_TRUE.
        /// 
        /// The function returns an empty string in the Interchange Warning parameter if no interchangeability warnings remain for the session.
        /// 
        /// In general, NI-FGEN generates interchangeability warnings when an attribute that affects the behavior of the instrument is in a state that you did not specify.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Buffer_Size">
        /// Pass the number of bytes in the ViChar array you specify for the interchangeWarning parameter.
        /// 
        /// If the next interchangeability warning string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies bufferSize - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size that you must pass to get the entire value. For example, if the value is "123456" and the buffer size is 4, the function places "123" into the buffer and returns 7.
        /// 
        /// If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
        /// 
        /// If you pass 0, you can pass VI_NULL for the Interchange Warning buffer parameter.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Interchange_Warning">
        /// Returns the next interchange warning for the IVI session. If there are no interchange warnings, the function returns an empty string.
        /// 
        /// The buffer must contain at least as many elements as the value you specify with the bufferSize parameter. If the next interchangeability warning string, including the terminating NUL byte, contains more bytes than you indicate with the bufferSize parameter, the function copies bufferSize - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size that you must pass to get the entire value.  For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7.
        /// 
        /// This parameter returns an empty string if no interchangeability
        /// warnings remain for the session.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use the niFgen_GetError and niFgen_ClearError functions.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int GetNextInterchangeWarning(int Buffer_Size, System.Text.StringBuilder Interchange_Warning)
        {
            int pInvokeResult = PInvoke.GetNextInterchangeWarning(this._handle, Buffer_Size, Interchange_Warning);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Clears the list of current interchange warnings.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use the niFgen_GetError and niFgen_ClearError functions.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int ClearInterchangeWarnings()
        {
            int pInvokeResult = PInvoke.ClearInterchangeWarnings(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// When developing a complex test system that consists of multiple test modules, it is generally a good idea to design the test modules so that they can run in any order.  To do so requires ensuring that each test module completely configures the state of each instrument it uses.  If a particular test module does not completely configure the state of an instrument, the state of the instrument depends on the configuration from a previously executed test module.  If you execute the test modules in a different order, the behavior of the instrument and therefore the entire test module is likely to change.  This change in behavior is generally instrument specific and represents an interchangeability problem.
        /// 
        /// You can use this function to test for such cases.  After you call this function, the interchangeability checking algorithms in the specific driver ignore all previous configuration operations.  By calling this function at the beginning of a test module, you can determine whether the test module has dependencies on the operation of previously executed test modules.
        /// 
        /// This function does not clear the interchangeability warnings from the list of previously recorded interchangeability warnings.  If you want to guarantee that niFgen_GetNextInterchangeWarning only returns those interchangeability warnings that are generated after calling this function, you must clear the list of interchangeability warnings.  You can clear the interchangeability warnings list by repeatedly calling niFgen_GetNextInterchangeWarning until no more interchangeability warnings are returned.  If you are not interested in the content of those warnings, you can call niFgen_ClearInterchangeWarnings.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message. To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int ResetInterchangeCheck()
        {
            int pInvokeResult = PInvoke.ResetInterchangeCheck(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Closes an NI-FGEN external calibration session and, if specified, stores the new calibration constants and calibration data, such as time and temperature, in the onboard EEPROM.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_InitExtCal. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Action">
        /// The action to perform upon closing. Valid choices are Abort, which disregards the new calibration constants, and Commit, which stores the new calibration constants on the device.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_EXT_CAL_ABORT - No changes are made to the calibration constants and data in the EEPROM.
        /// 
        /// NIFGEN_VAL_EXT_CAL_COMMIT - The new calibration constants and data determined during the external calibration session are stored in the onboard EEPROM.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message. To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int CloseExtCal(int Action)
        {
            int pInvokeResult = PInvoke.CloseExtCal(this._handle, Action);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Performs a full internal (self-) calibration on the device.  If the calibration is successful, new calibration data and constants are stored in the onboard EEPROM.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use the niFgen_GetError and niFgen_ClearError functions.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int SelfCal()
        {
            int pInvokeResult = PInvoke.SelfCal(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function sets up the device to start the analog output calibration.
        /// 
        /// The session handle should be the handle returned by niFgen_InitExtCal.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_InitExtCal.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use the niFgen_GetError and niFgen_ClearError functions.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int InitializeAnalogOutputCalibration()
        {
            int pInvokeResult = PInvoke.InitializeAnalogOutputCalibration(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Writes the 16-bit value to the DAC, which could be output as a DC voltage. This function writes to the DAC only when in an external calibration session.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_InitExtCal. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// Pass the channel name for which you want to write the value.
        /// 
        /// Default Value: "0"
        /// 
        /// </param>
        /// <param name="Value">
        /// The value to write.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message. To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int WriteBinary16AnalogStaticValue(string Channel_Name, short Value)
        {
            int pInvokeResult = PInvoke.WriteBinary16AnalogStaticValue(this._handle, Channel_Name, Value);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Calculates calibration constants pertaining to the pre-amplifier offset of the main analog path. During external calibration, you can put the device in different configurations; program different gain, offset, and main DAC values; and take measurements of the resulting output voltage. The configuration data as well as the measurements, are passed to this function so that, NI-FGEN can calculate the appropriate calibration constants and, when the calibration session is committed, store them in the onboard EEPROM.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle returned niFgen_InitExtCal.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// The name of the channel being calibrated.
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Configuration">
        /// Pre-amp stage configuration.
        /// </param>
        /// <param name="Gain_DAC_Values">
        /// An array of the values programmed to the gain calibration DAC during this calibration stage.
        /// </param>
        /// <param name="Offset_DAC_Values">
        /// An array of the values programmed to the offset calibration DAC during this calibration stage.
        /// </param>
        /// <param name="Measured_Outputs">
        /// An array of the analog output voltages measured during this calibration stage.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int CalAdjustMainPathPreAmpOffset(string Channel_Name, int Configuration, long[] Gain_DAC_Values, long[] Offset_DAC_Values, System.Double[] Measured_Outputs)
        {
            int pInvokeResult = PInvoke.CalAdjustMainPathPreAmpOffset(this._handle, Channel_Name, Configuration, Gain_DAC_Values, Offset_DAC_Values, Measured_Outputs);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Calculates calibration constants pertaining to the pre-amplifier gain of the main analog path. During external calibration, you can put the device in different configurations; program different gain, offset, and main DAC values; and take measurements of the resulting output voltage. The configuration data, as well as the measurements, are passed to this function so that NI-FGEN can calculate the appropriate calibration constants and, when the calibration session is committed, store them in the onboard EEPROM.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle returned from niFgen_InitExtCal.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// The name of the channel being calibrated.
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Configuration">
        /// Pre-amp stage configuration.
        /// </param>
        /// <param name="Main_DAC_Values">
        /// An array of the values programmed to the main output DAC during this calibration stage.
        /// </param>
        /// <param name="Gain_DAC_Values">
        /// An array of the values programmed to the gain calibration DAC during this calibration stage.
        /// </param>
        /// <param name="Offset_DAC_Values">
        /// An array of the values programmed to the offset calibration DAC during this calibration stage.
        /// </param>
        /// <param name="Measured_Outputs">
        /// An array of the analog output voltages measured during this calibration stage.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message. To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int CalAdjustMainPathPreAmpGain(string Channel_Name, int Configuration, long[] Main_DAC_Values, long[] Gain_DAC_Values, long[] Offset_DAC_Values, System.Double[] Measured_Outputs)
        {
            int pInvokeResult = PInvoke.CalAdjustMainPathPreAmpGain(this._handle, Channel_Name, Configuration, Main_DAC_Values, Gain_DAC_Values, Offset_DAC_Values, Measured_Outputs);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Calculates calibration constants pertaining to the post-amplifier gain and offset of the main analog path. During external calibration, you can put the device in different configurations; program different gain, offset, and main DAC values; and take measurements of the resulting output voltage.  The configuration data, as well as the measurements, are passed to this function so that NI-FGEN can calculate the appropriate calibration constants and, when the calibration session is committed, store them in the onboard EEPROM.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle returned from niFgen_InitExtCal.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// The name of the channel being calibrated.
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Configuration">
        /// Post-amp stage configuration.
        /// </param>
        /// <param name="Main_DAC_Values">
        /// An array of the values programmed to the gain calibration DAC during this calibration stage.
        /// </param>
        /// <param name="Gain_DAC_Values">
        /// An array of the values programmed to the gain calibration DAC during this calibration stage.
        /// </param>
        /// <param name="Offset_DAC_Values">
        /// An array of the values programmed to the offset calibration DAC during this calibration stage.
        /// </param>
        /// <param name="Measured_Outputs">
        /// An array of the analog output voltages measured during this calibration stage.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message. To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int CalAdjustMainPathPostAmpGainAndOffset(string Channel_Name, int Configuration, long[] Main_DAC_Values, long[] Gain_DAC_Values, long[] Offset_DAC_Values, System.Double[] Measured_Outputs)
        {
            int pInvokeResult = PInvoke.CalAdjustMainPathPostAmpGainAndOffset(this._handle, Channel_Name, Configuration, Main_DAC_Values, Gain_DAC_Values, Offset_DAC_Values, Measured_Outputs);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Calculates calibration constants pertaining to the gain of the direct analog path. During external calibration, you can put the device in different configurations; program different gain and main DAC values; and take measurements of the resulting output voltage. The configuration data, as well as the measurements, are passed to this function so that NI-FGEN can calculate the appropriate calibration constants and, when the calibration session is committed, store them in the onboard EEPROM.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle returned from niFgen_InitExtCal.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// The name of the channel being calibrated.
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Main_DAC_Values">
        /// An array of the values programmed to the main output DAC during this calibration stage.
        /// </param>
        /// <param name="Gain_DAC_Values">
        /// An array of the values programmed to the gain calibration DAC during this calibration stage.
        /// </param>
        /// <param name="Measured_Outputs">
        /// An array of the analog output voltages measured during this calibration stage.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int CalAdjustDirectPathGain(string Channel_Name, long[] Main_DAC_Values, long[] Gain_DAC_Values, System.Double[] Measured_Outputs)
        {
            int pInvokeResult = PInvoke.CalAdjustDirectPathGain(this._handle, Channel_Name, Main_DAC_Values, Gain_DAC_Values, Measured_Outputs);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Calculates calibration constants pertaining to main analog path output impedance.  During external calibration, you can put the device in different configurations and take measurements of the resulting output voltage across different loads.  The configuration data, as well as the measurements, are passed to this function so that NI-FGEN can calculate the appropriate calibration constants and, when the calibration session is committed, store them in the onboard EEPROM.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle returned from niFgen_InitExtCal.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// The name of the channel being calibrated.
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Configuration">
        /// Main path output impedance configuration.
        /// </param>
        /// <param name="Load_Impedance">
        /// The impedance of the load across which the measurement passed in as measuredVoltageAcrossLoad is taken.
        /// </param>
        /// <param name="Measured_Source_Voltage">
        /// The analog output voltage measured across a very high-impedance load.
        /// </param>
        /// <param name="Measured_Voltage_Across_Load">
        /// The analog output voltage measured across the load impedance specified in the loadImpedance parameter.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int CalAdjustMainPathOutputImpedance(string Channel_Name, int Configuration, System.Double Load_Impedance, System.Double Measured_Source_Voltage, System.Double Measured_Voltage_Across_Load)
        {
            int pInvokeResult = PInvoke.CalAdjustMainPathOutputImpedance(this._handle, Channel_Name, Configuration, Load_Impedance, Measured_Source_Voltage, Measured_Voltage_Across_Load);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Calculates calibration constants pertaining to direct analog path output impedance. During external calibration, you can put the device in different configurations and take measurements of the resulting output voltage across different loads. The configuration data, as well as the measurements, are passed to this function so that NI-FGEN can calculate the appropriate calibration constants and, when the calibration session is committed, store them in the onboard EEPROM.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle returned from niFgen_InitExtCal.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// The name of the channel being calibrated.
        /// 
        /// Default Value: "0"
        /// </param>
        /// <param name="Configuration">
        /// Direct path output impedance configuration.
        /// </param>
        /// <param name="Load_Impedance">
        /// The impedance of the load across which the measurement passed in as measuredVoltageAcrossLoad is taken.
        /// </param>
        /// <param name="Measured_Source_Voltage">
        /// The analog output voltage measured across a very high-impedance load.
        /// </param>
        /// <param name="Measured_Voltage_Across_Load">
        /// The analog output voltage measured across the load impedance specified in the loadImpedance parameter.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int CalAdjustDirectPathOutputImpedance(string Channel_Name, int Configuration, System.Double Load_Impedance, System.Double Measured_Source_Voltage, System.Double Measured_Voltage_Across_Load)
        {
            int pInvokeResult = PInvoke.CalAdjustDirectPathOutputImpedance(this._handle, Channel_Name, Configuration, Load_Impedance, Measured_Source_Voltage, Measured_Voltage_Across_Load);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This functions sets up the device to start the VCXO calibration.
        /// 
        /// The session handle should be the handle returned by niFgen_InitExtCal.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_InitExtCal. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message. To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int InitializeOscillatorFrequencyCalibration()
        {
            int pInvokeResult = PInvoke.InitializeOscillatorFrequencyCalibration(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Calculates calibration constants pertaining to the VCXO.  During external calibration, you can generate sine waves and take measurements of the resulting output frequency.  The desired and measured frequencies are passed to this function so that NI-FGEN can calculate the appropriate calibration constants and, when the calibration session is committed, store them in the onboard EEPROM.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle returned niFgen_InitExtCal.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Desired_Frequency">
        /// The expected frequency of the output waveform.
        /// </param>
        /// <param name="Measured_Frequency">
        /// The actual (measured) frequency of the output waveform.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int CalAdjustOscillatorFrequency(System.Double Desired_Frequency, System.Double Measured_Frequency)
        {
            int pInvokeResult = PInvoke.CalAdjustOscillatorFrequency(this._handle, Desired_Frequency, Measured_Frequency);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Initializes an external calibration session for calibration ADC calibration.  For the NI 5421/5422/5441, calibration ADC calibration involves characterizing the gain and offset of the onboard calibration ADC.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_InitExtCal.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int InitializeCalADCCalibration()
        {
            int pInvokeResult = PInvoke.InitializeCalADCCalibration(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Calculates calibration constants pertaining to the gain and offset of the on-board calibration ADC.  During external calibration, you can output voltages and measure them both externally and with the calibration ADC.  The measured voltages are passed to this function so that NI-FGEN can calculate the appropriate calibration constants and, when the calibration session is committed, store them in the onboard EEPROM.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle returned from niFgen_InitExtCal.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Voltages_Measured_Externally">
        /// An array of analog output voltages measured with an external instrument.
        /// </param>
        /// <param name="Voltages_Measured_With_CalADC">
        /// An array of analog output voltages measured with the onboard calibration ADC.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int CalAdjustCalADC(System.Double[] Voltages_Measured_Externally, System.Double[] Voltages_Measured_With_CalADC)
        {
            int pInvokeResult = PInvoke.CalAdjustCalADC(this._handle, Voltages_Measured_Externally, Voltages_Measured_With_CalADC);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Takes one or more voltage measurements from the onboard calibration ADC and returns their average value. The signal that the ADC actually measures can be specified using NIFGEN_ATTR_CAL_ADC_INPUT. The ADC has some inherent gain and offset. These values can be determined during an external calibration session and stored in the calibration EEPROM.
        /// 
        /// If the returnCalibratedValue parameter is VI_TRUE, NI-FGEN adjusts the value that is returned to account for the gain and offset of the ADC. Otherwise, the raw voltage value reported by the ADC is returned.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle returned from niFgen_init or niFgen_InitExtCal.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Number_of_Reads_to_Average">
        /// Specifies the number of measurements to be taken and averaged to determine the return value.
        /// </param>
        /// <param name="Return_Calibrated_Value">
        /// Specifies whether the voltage returned from the ADC should be adjusted to account for the gain and offset of the ADC.
        /// </param>
        /// <param name="Cal_ADC_Value">
        /// The average of the voltage measurements taken from the onboard calibration ADC.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message. To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int ReadCalADC(int Number_of_Reads_to_Average, bool Return_Calibrated_Value, out System.Double Cal_ADC_Value)
        {
            int pInvokeResult = PInvoke.ReadCalADC(this._handle, Number_of_Reads_to_Average, System.Convert.ToUInt16(Return_Calibrated_Value), out Cal_ADC_Value);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns whether or not the device supports self-calibration.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Self_Cal_Supported">
        /// VI_TRUE if self-calibration is supported. VI_FALSE otherwise.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int GetSelfCalSupported(out bool Self_Cal_Supported)
        {
            System.UInt16 Self_Cal_SupportedAsUShort;
            int pInvokeResult = PInvoke.GetSelfCalSupported(this._handle, out Self_Cal_SupportedAsUShort);
            Self_Cal_Supported = System.Convert.ToBoolean(Self_Cal_SupportedAsUShort);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the date and time of the last successful self-calibration.  The time returned is 24-hour (military) local time; for example, if the device was calibrated at 2:30 PM, this function will return 14 for the hours parameter and 30 for the minutes parameter.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitExtCal.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Year">
        /// The year of the last successful calibration.
        /// </param>
        /// <param name="Month">
        /// The month of the last successful calibration.
        /// </param>
        /// <param name="Day">
        /// The day of the last successful calibration.
        /// </param>
        /// <param name="Hour">
        /// The hour of the last successful calibration.
        /// </param>
        /// <param name="Minute">
        /// The minute of the last successful calibration.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int GetSelfCalLastDateAndTime(out int Year, out int Month, out int Day, out int Hour, out int Minute)
        {
            int pInvokeResult = PInvoke.GetSelfCalLastDateAndTime(this._handle, out Year, out Month, out Day, out Hour, out Minute);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the date and time of the last successful external calibration.  The time returned is 24-hour (military) local time; for example, if the device was calibrated at 2:30 PM, this function will return 14 for the hours parameter and 30 for the minutes parameter.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitExtCal.  The handle identifies a particular instrument session.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Year">
        /// The year of the last successful calibration.
        /// </param>
        /// <param name="Month">
        /// The month of the last successful calibration.
        /// </param>
        /// <param name="Day">
        /// The day of the last successful calibration.
        /// </param>
        /// <param name="Hour">
        /// The hour of the last successful calibration.
        /// </param>
        /// <param name="Minute">
        /// The minute of the last successful calibration.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int GetExtCalLastDateAndTime(out int Year, out int Month, out int Day, out int Hour, out int Minute)
        {
            int pInvokeResult = PInvoke.GetExtCalLastDateAndTime(this._handle, out Year, out Month, out Day, out Hour, out Minute);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the temperature at the last successful self-calibration.  The temperature is returned in degrees Celsius.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle returned from niFgen_init or niFgen_InitExtCal.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Temperature">
        /// The temperature at the last successful calibration.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int GetSelfCalLastTemp(out System.Double Temperature)
        {
            int pInvokeResult = PInvoke.GetSelfCalLastTemp(this._handle, out Temperature);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the temperature at the last successful external calibration.  The temperature is returned in degrees Celsius.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle returned from niFgen_init or niFgen_InitExtCal.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Temperature">
        /// The temperature at the last successful calibration.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int GetExtCalLastTemp(out System.Double Temperature)
        {
            int pInvokeResult = PInvoke.GetExtCalLastTemp(this._handle, out Temperature);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the recommended interval between external calibrations in months.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle returned from niFgen_init or niFgen_InitExtCal.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Months">
        /// The recommended interval between external calibrations in months.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int GetExtCalRecommendedInterval(out int Months)
        {
            int pInvokeResult = PInvoke.GetExtCalRecommendedInterval(this._handle, out Months);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Changes the password that is required to initialize an external calibration session.  The password may be up to four characters long.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle returned from niFgen_init or niFgen_InitExtCal.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Old_Password">
        /// The old (current) external calibration password.
        /// </param>
        /// <param name="New_Password">
        /// The new (desired) external calibration password.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int ChangeExtCalPassword(string Old_Password, string New_Password)
        {
            int pInvokeResult = PInvoke.ChangeExtCalPassword(this._handle, Old_Password, New_Password);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Stores user-defined information in the onboard EEPROM.  Use niFgen_GetCalUserDefinedInfoMaxSize to determine the number of characters that can be stored.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle returned from niFgen_init or niFgen_InitExtCal.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Info">
        /// The information string that should be stored in the EEPROM.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int SetCalUserDefinedInfo(string Info)
        {
            int pInvokeResult = PInvoke.SetCalUserDefinedInfo(this._handle, Info);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Retrieves user-defined information from the onboard EEPROM.  Use niFgen_GetCalUserDefinedInfoMaxSize to determine the number of characters that can be retrieved.  The buffer provided by the user should be the size of the maximum number of characters stored plus one termination character.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle returned from niFgen_init or niFgen_InitExtCal.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Info">
        /// A string into which the user information is copied.  This paramenter must point to a character buffer large enough to hold the information string.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int GetCalUserDefinedInfo(string Info)
        {
            int pInvokeResult = PInvoke.GetCalUserDefinedInfo(this._handle, Info);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the maximum number of characters (excluding the termination character) of user-defined information that can be stored in the onboard EEPROM.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle returned from niFgen_init or niFgen_InitExtCal.
        /// 
        /// Default Value:  None
        /// 
        /// </param>
        /// <param name="Info_Size">
        /// The maximum number of characters of user defined info that can be stored in the onboard EEPROM.
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int GetCalUserDefinedInfoMaxSize(out int Info_Size)
        {
            int pInvokeResult = PInvoke.GetCalUserDefinedInfoMaxSize(this._handle, out Info_Size);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Reads the current onboard temperature of the device. The temperature is returned in degrees Celsius.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle returned from niFgen_init or niFgen_InitExtCal.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Temperature">
        /// Current temperature read from onboard temperature sensors (degrees Celsius).
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message. To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int ReadCurrentTemperature(out System.Double Temperature)
        {
            int pInvokeResult = PInvoke.ReadCurrentTemperature(this._handle, out Temperature);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Overwrites the current calibration constants with those from the last successful external calibration. This action effectively undoes any self-calibrations performed since the last time an external calibration was performed. This function should be used if a self-calibration produced invalid calibration constants.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_InitExtCal. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation.
        /// 
        /// To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message. To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
        /// 
        /// Status Codes
        /// 
        /// Status    Description
        /// -------------------------------------------------
        ///        0  No error (the call was successful).
        /// 
        /// 3FFF0005  The specified termination character was read.
        /// 3FFF0006  The specified number of bytes was read.
        /// 
        /// 3FFC0102  Reset not supported.
        /// 
        /// BFFF0000  Miscellaneous or system error occurred.
        /// BFFF000E  Invalid session handle.
        /// BFFF0015  Timeout occurred before operation could complete.
        /// BFFF0034  Violation of raw write protocol occurred.
        /// BFFF0035  Violation of raw read protocol occurred.
        /// BFFF0036  Device reported an output protocol error.
        /// BFFF0037  Device reported an input protocol error.
        /// BFFF0038  Bus error occurred during transfer.
        /// BFFF003A  Invalid setup (attributes are not consistent).
        /// BFFF005F  A "no listeners" condition was detected.
        /// BFFF0060  This interface is not the controller-in-charge.
        /// BFFF0067  Operation is not supported on this session.
        /// 
        /// </returns>
        public int RestoreLastExtCalConstants()
        {
            int pInvokeResult = PInvoke.RestoreLastExtCalConstants(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Creates an arbitrary waveform and returns a handle that identifies that waveform. You can pass this handle to niFgen_ConfigureArbWaveform to produce that waveform. You can also use the handles this function returns to specify a sequence of arbitrary waveforms with niFgen_CreateArbSequence.
        /// 
        /// Notes:
        /// 
        /// (1) You must set the output mode to NIFGEN_VAL_OUTPUT_ARB before calling this function.
        /// 
        /// (2) You must scale the data between -1.00 and +1.00. Use the Gain parameter to generate different output voltages. 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Waveform_Size">
        /// Pass the size of the arbitrary waveform that you want created.
        /// 
        /// The size must meet the following restrictions:
        /// 
        /// - The size must be less than or equal to the maximum waveform size that the device allows.
        /// - The size must be greater than or equal to the minimum waveform size that the device allows.
        /// - The size must be an integer multiple of the device waveform quantum.
        /// 
        /// You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in niFgen_QueryArbWfmCapabilities.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Waveform_Data_Array">
        /// Specify the array of data that you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in the Waveform Size parameter.
        /// 
        /// You must normalize the data points in the array to be between -1.00 and +1.00.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Waveform_Handle">
        /// Returns the handle that identifies the new arbitrary waveform.  You can pass this handle to niFgen_ConfigureArbWaveform to generate the arbitrary waveform. You can pass an array of these handles to niFgen_CreateArbSequence to create an arbitrary sequence.
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int CreateArbWaveform(int Waveform_Size, System.Double[] Waveform_Data_Array, out int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.CreateArbWaveform(this._handle, Waveform_Size, Waveform_Data_Array, out Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Creates an arbitrary waveform from binary data and returns a handle that identifies that waveform. You can pass this handle to niFgen_ConfigureArbWaveform to produce that waveform. You can also use the handles this function returns to specify a sequence of arbitrary waveforms with niFgen_CreateArbSequence.
        /// 
        /// Notes:  You must set the output mode to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Waveform_Size">
        /// Pass the size of the arbitrary waveform that you want created.
        /// 
        /// The size must meet the following restrictions:
        /// 
        /// - The size must be less than or equal to the maximum waveform size that the instrument allows.
        /// - The size must be greater than or equal to the minimum waveform size the instrument allows.
        /// - The size must be an integer multiple of the instrument waveform quantum.
        /// 
        /// You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in niFgen_QueryArbWfmCapabilities.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Waveform_Data_Array">
        /// Specify the array of data that you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in the waveformSize parameter.
        /// 
        /// You must normalize the data points in the array to be between -32768 and +32767.
        /// 
        /// Default Value: None
        /// 
        /// </param>
        /// <param name="Waveform_Handle">
        /// Returns the handle that identifies the new arbitrary waveform.  You can pass this handle to niFgen_ConfigureArbWaveform to generate the arbitrary waveform. You can also pass an array of these handles to niFgen_CreateArbSequence to create an arbitrary sequence.
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
        ///           
        /// The general meaning of the status code is as follows.
        /// 
        /// Value                  Meaning
        /// -------------------------------
        /// 0                      Success
        /// Positive Values        Warnings
        /// Negative Values        Errors
        /// 
        /// NI-FGEN defines the following status codes.
        ///           
        /// Status        Description
        /// -------------------------------------------------
        /// ERRORS
        /// 
        /// BFFA4001      Internal Driver Error: DAQ Parameter change
        /// BFFA4002      Internal Driver Error: DAQ Group Control
        /// BFFA4003      Internal Driver Error: DAQ Select Signal
        /// BFFA4004      Internal Driver Error: DAQ Group Setup
        /// BFFA4005      Internal Driver Error: DAQ Configure
        /// BFFA4006      Internal Driver Error: DAQ Init Board
        /// BFFA4007      Internal Driver Error: DAQ Waveform Load
        /// BFFA4008      Internal Driver Error: DAQ Get Attribute
        /// BFFA4009      Invalid Frequency List
        /// BFFA400A      No Frequency Lists Available
        /// BFFA400B      Invalid Frequency List Length
        /// BFFA400C      Internal Driver Error: DAQ Clock Rate
        /// BFFA400D      Invalid Sample Count
        /// BFFA400E      Invalid Marker
        /// BFFA400F      Invalid Frequency
        /// BFFA4010      Invalid Duration
        /// BFFA4011      Internal Driver Error: DAQ Set Clock
        /// BFFA4012      Internal Driver Error: DAQ Device Info
        /// 
        /// NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
        ///           
        /// Numeric Range (in Hex)   Include  Code Types    
        /// -------------------------------------------------
        /// 3FFA2000 to 3FFA3FFF     IviFgen  Warnings
        /// 3FFA0000 to 3FFA1FFF     IVI      Warnings
        /// 3FFF0000 to 3FFFFFFF     VISA     Warnings
        /// 3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
        ///           
        /// BFFA2000 to BFFA3FFF     IviFgen  Errors
        /// BFFA0000 to BFFA1FFF     IVI      Errors
        /// BFFF0000 to BFFFFFFF     VISA     Errors
        /// BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
        /// 
        /// 
        /// </returns>
        public int CreateBinary16ArbWaveform(int Waveform_Size, short[] Waveform_Data_Array, out int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.CreateBinary16ArbWaveform(this._handle, Waveform_Size, Waveform_Data_Array, out Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        public void Dispose()
        {
            this.Dispose(true);
            System.GC.SuppressFinalize(this);
        }
        
        private void Dispose(bool disposing)
        {
            if ((this._disposed == false))
            {
                PInvoke.close(this._handle);
                this._handle = System.IntPtr.Zero;
            }
            this._disposed = true;
        }
        
        public void SetInt32(niFgenProperties propertyId, string repeatedCapabilityOrChannel, int val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViInt32(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }
        
        public void SetInt32(niFgenProperties propertyId, int val)
        {
            this.SetInt32(propertyId, "", val);
        }
        
        public int GetInt32(niFgenProperties propertyId, string repeatedCapabilityOrChannel)
        {
            int val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViInt32(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return val;
        }
        
        public int GetInt32(niFgenProperties propertyId)
        {
            return this.GetInt32(propertyId, "");
        }
        
        public void SetDouble(niFgenProperties propertyId, string repeatedCapabilityOrChannel, System.Double val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViReal64(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }
        
        public void SetDouble(niFgenProperties propertyId, System.Double val)
        {
            this.SetDouble(propertyId, "", val);
        }
        
        public System.Double GetDouble(niFgenProperties propertyId, string repeatedCapabilityOrChannel)
        {
            System.Double val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViReal64(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return val;
        }
        
        public System.Double GetDouble(niFgenProperties propertyId)
        {
            return this.GetDouble(propertyId, "");
        }
        
        public void SetBoolean(niFgenProperties propertyId, string repeatedCapabilityOrChannel, bool val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViBoolean(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), System.Convert.ToUInt16(val)));
        }
        
        public void SetBoolean(niFgenProperties propertyId, bool val)
        {
            this.SetBoolean(propertyId, "", val);
        }
        
        public bool GetBoolean(niFgenProperties propertyId, string repeatedCapabilityOrChannel)
        {
            System.UInt16 val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViBoolean(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return System.Convert.ToBoolean(val);
        }
        
        public bool GetBoolean(niFgenProperties propertyId)
        {
            return this.GetBoolean(propertyId, "");
        }
        
        public void SetString(niFgenProperties propertyId, string repeatedCapabilityOrChannel, string val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViString(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }
        
        public void SetString(niFgenProperties propertyId, string val)
        {
            this.SetString(propertyId, "", val);
        }
        
        public string GetString(niFgenProperties propertyId, string repeatedCapabilityOrChannel)
        {
            System.Text.StringBuilder newVal = new System.Text.StringBuilder(512);
            int size = PInvoke.GetAttributeViString(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), 512, newVal);
            if ((size < 0))
            {
                PInvoke.ThrowError(this._handle, size);
            }
            else
            {
                if ((size > 0))
                {
                    newVal.Capacity = size;
                    PInvoke.TestForError(this._handle, PInvoke.GetAttributeViString(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), size, newVal));
                }
            }
            return newVal.ToString();
        }
        
        public string GetString(niFgenProperties propertyId)
        {
            return this.GetString(propertyId, "");
        }
        
        public void SetSession(niFgenProperties propertyId, string repeatedCapabilityOrChannel, System.IntPtr val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViSession(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }
        
        public void SetSession(niFgenProperties propertyId, System.IntPtr val)
        {
            this.SetSession(propertyId, "", val);
        }
        
        public System.IntPtr GetSession(niFgenProperties propertyId, string repeatedCapabilityOrChannel)
        {
            System.IntPtr val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViSession(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return val;
        }
        
        public System.IntPtr GetSession(niFgenProperties propertyId)
        {
            return this.GetSession(propertyId, "");
        }
        
        private class PInvoke
        {
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_init",CallingConvention=CallingConvention.StdCall)]
            public static extern int init (string Resource_Name, System.UInt16 ID_Query, System.UInt16 Reset_Device, out System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_InitWithOptions",CallingConvention=CallingConvention.StdCall)]
            public static extern int InitWithOptions (string Resource_Name, System.UInt16 ID_Query, System.UInt16 Reset_Device, string Option_String, out System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_InitExtCal",CallingConvention=CallingConvention.StdCall)]
            public static extern int InitExtCal (string Resource_Name, string Password, out System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_Commit",CallingConvention=CallingConvention.StdCall)]
            public static extern int Commit (System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_reset",CallingConvention=CallingConvention.StdCall)]
            public static extern int reset (System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureOperationMode",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureOperationMode (System.IntPtr Instrument_Handle, string Channel_Name, int Operation_Mode);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureOutputMode",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureOutputMode (System.IntPtr Instrument_Handle, int Output_Mode);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureOutputEnabled",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureOutputEnabled (System.IntPtr Instrument_Handle, string Channel_Name, System.UInt16 Enabled);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureOutputImpedance",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureOutputImpedance (System.IntPtr Instrument_Handle, string Channel_Name, System.Double Impedance);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_EnableAnalogFilter",CallingConvention=CallingConvention.StdCall)]
            public static extern int EnableAnalogFilter (System.IntPtr Instrument_Handle, string Channel_Name, System.Double Filter_Correction_Frequency);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_DisableAnalogFilter",CallingConvention=CallingConvention.StdCall)]
            public static extern int DisableAnalogFilter (System.IntPtr Instrument_Handle, string Channel_Name);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_EnableDigitalFilter",CallingConvention=CallingConvention.StdCall)]
            public static extern int EnableDigitalFilter (System.IntPtr Instrument_Handle, string Channel_Name);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_DisableDigitalFilter",CallingConvention=CallingConvention.StdCall)]
            public static extern int DisableDigitalFilter (System.IntPtr Instrument_Handle, string Channel_Name);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_EnableDigitalPatterning",CallingConvention=CallingConvention.StdCall)]
            public static extern int EnableDigitalPatterning (System.IntPtr Instrument_Handle, string Channel_Name);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_DisableDigitalPatterning",CallingConvention=CallingConvention.StdCall)]
            public static extern int DisableDigitalPatterning (System.IntPtr Instrument_Handle, string Channel_Name);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureStandardWaveform",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureStandardWaveform (System.IntPtr Instrument_Handle, string Channel_Name, int Waveform, System.Double Amplitude, System.Double DC_Offset, System.Double Frequency, System.Double Start_Phase);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_DefineUserStandardWaveform",CallingConvention=CallingConvention.StdCall)]
            public static extern int DefineUserStandardWaveform (System.IntPtr Instrument_Handle, string Channel_Name, int Waveform_Size, System.Double[] Waveform_Data_Array);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ClearUserStandardWaveform",CallingConvention=CallingConvention.StdCall)]
            public static extern int ClearUserStandardWaveform (System.IntPtr Instrument_Handle, string Channel_Name);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureFrequency",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureFrequency (System.IntPtr Instrument_Handle, string Channel_Name, System.Double Frequency);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureAmplitude",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureAmplitude (System.IntPtr Instrument_Handle, string Channel_Name, System.Double Amplitude);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CreateFreqList",CallingConvention=CallingConvention.StdCall)]
            public static extern int CreateFreqList (System.IntPtr Instrument_Handle, int Waveform, int Frequency_List_Length, System.Double[] Frequency_Array, System.Double[] Duration_Array, out int Frequency_List_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureFreqList",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureFreqList (System.IntPtr Instrument_Handle, string Channel_Name, int Frequency_List_Handle, System.Double Amplitude, System.Double DC_Offset, System.Double Start_Phase);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ClearFreqList",CallingConvention=CallingConvention.StdCall)]
            public static extern int ClearFreqList (System.IntPtr Instrument_Handle, int Frequency_List_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_QueryFreqListCapabilities",CallingConvention=CallingConvention.StdCall)]
            public static extern int QueryFreqListCapabilities (System.IntPtr Instrument_Handle, out int Maximum_Number_Of_Freq_Lists, out int Minimum_Frequency_List_Length, out int Maximum_Frequency_List_Length, out System.Double Minimum_Frequency_List_Duration, out System.Double Maximum_Frequency_List_Duration, out System.Double Frequency_List_Duration_Quantum);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureGain",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureGain (System.IntPtr Instrument_Handle, string Channel_Name, System.Double Gain);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureSampleRate",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureSampleRate (System.IntPtr Instrument_Handle, System.Double Sample_Rate);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_QueryArbWfmCapabilities",CallingConvention=CallingConvention.StdCall)]
            public static extern int QueryArbWfmCapabilities (System.IntPtr Instrument_Handle, out int Maximum_Number_of_Waveforms, out int Waveform_Quantum, out int Minimum_Waveform_Size, out int Maximum_Waveform_Size);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CreateWaveformF64",CallingConvention=CallingConvention.StdCall)]
            public static extern int CreateWaveformF64 (System.IntPtr Instrument_Handle, string Channel_Name, int Waveform_Size, System.Double[] Waveform_Data_Array, out int Waveform_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CreateWaveformI16",CallingConvention=CallingConvention.StdCall)]
            public static extern int CreateWaveformI16 (System.IntPtr Instrument_Handle, string Channel_Name, int Waveform_Size, short[] Waveform_Data_Array, out int Waveform_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CreateWaveformComplexF64",CallingConvention=CallingConvention.StdCall)]
            public static extern int CreateWaveformComplexF64 (System.IntPtr Instrument_Handle, string Channel_Name, int Number_of_Samples, niFgenComplexF64[] Waveform_Data_Array, out int Waveform_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CreateWaveformFromFileI16",CallingConvention=CallingConvention.StdCall)]
            public static extern int CreateWaveformFromFileI16 (System.IntPtr Instrument_Handle, string Channel_Name, string FileName, int Byte_Order, out int Waveform_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CreateWaveformFromFileF64",CallingConvention=CallingConvention.StdCall)]
            public static extern int CreateWaveformFromFileF64 (System.IntPtr Instrument_Handle, string Channel_Name, string FileName, int Byte_Order, out int Waveform_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CreateWaveformFromFileHWS",CallingConvention=CallingConvention.StdCall)]
            public static extern int CreateWaveformFromFileHWS (System.IntPtr Instrument_Handle, string Channel_Name, string FileName, System.UInt16 Use_Rate_From_Waveform, System.UInt16 Use_Gain___Offset_From_Waveform, out int Waveform_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureArbWaveform",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureArbWaveform (System.IntPtr Instrument_Handle, string Channel_Name, int Waveform_Handle, System.Double Gain, System.Double Offset);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ClearArbWaveform",CallingConvention=CallingConvention.StdCall)]
            public static extern int ClearArbWaveform (System.IntPtr Instrument_Handle, int Waveform_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_QueryArbSeqCapabilities",CallingConvention=CallingConvention.StdCall)]
            public static extern int QueryArbSeqCapabilities (System.IntPtr Instrument_Handle, out int Maximum_Number_of_Sequences, out int Minimum_Sequence_Length, out int Maximum_Sequence_Length, out int Maximum_Loop_Count);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CreateArbSequence",CallingConvention=CallingConvention.StdCall)]
            public static extern int CreateArbSequence (System.IntPtr Instrument_Handle, int Sequence_Length, long[] Waveform_Handles_Array, long[] Loop_Counts_Array, out int Sequence_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CreateAdvancedArbSequence",CallingConvention=CallingConvention.StdCall)]
            public static extern int CreateAdvancedArbSequence (System.IntPtr Instrument_Handle, int Sequence_Length, long[] Waveform_Handles_Array, long[] Loop_Counts_Array, long[] Sample_Counts_Array, long[] Marker_Location_Array, long[] Coerced_Markers_Array, out int Sequence_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureArbSequence",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureArbSequence (System.IntPtr Instrument_Handle, string Channel_Name, int Sequence_Handle, System.Double Gain, System.Double Offset);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ClearArbSequence",CallingConvention=CallingConvention.StdCall)]
            public static extern int ClearArbSequence (System.IntPtr Instrument_Handle, int Sequence_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ClearArbMemory",CallingConvention=CallingConvention.StdCall)]
            public static extern int ClearArbMemory (System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_AllocateWaveform",CallingConvention=CallingConvention.StdCall)]
            public static extern int AllocateWaveform (System.IntPtr Instrument_Handle, string Channel_Name, int Waveform_Size, out int Waveform_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_SetWaveformNextWritePosition",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetWaveformNextWritePosition (System.IntPtr Instrument_Handle, string Channel_Name, int Waveform_Handle, int relativeTo, int offset);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_WriteWaveform",CallingConvention=CallingConvention.StdCall)]
            public static extern int WriteWaveform (System.IntPtr Instrument_Handle, string Channel_Name, int Waveform_Handle, int Size, System.Double[] Data);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_WriteWaveformComplexF64",CallingConvention=CallingConvention.StdCall)]
            public static extern int WriteWaveformComplexF64 (System.IntPtr Instrument_Handle, string Channel_Name, int Number_of_Samples, niFgenComplexF64[] Data, int Waveform_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_WriteBinary16Waveform",CallingConvention=CallingConvention.StdCall)]
            public static extern int WriteBinary16Waveform (System.IntPtr Instrument_Handle, string Channel_Name, int Waveform_Handle, int Size, short[] Data);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureRefClockSource",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureRefClockSource (System.IntPtr Instrument_Handle, int Reference_Clock_Source);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureRefClockFrequency",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureRefClockFrequency (System.IntPtr Instrument_Handle, System.Double Reference_Clock_Frequency);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureClockMode",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureClockMode (System.IntPtr Instrument_Handle, int Clock_Mode);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureUpdateClockSource",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureUpdateClockSource (System.IntPtr Instrument_Handle, int Update_Clock_Source);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_AdjustSampleClockRelativeDelay",CallingConvention=CallingConvention.StdCall)]
            public static extern int AdjustSampleClockRelativeDelay (System.IntPtr Instrument_Handle, System.Double Adjustment_Time);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureTriggerSource",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureTriggerSource (System.IntPtr Instrument_Handle, string Channel_Name, int Trigger_Source);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureTriggerMode",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureTriggerMode (System.IntPtr Instrument_Handle, string Channel_Name, int Trigger_Mode);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_RouteSignalOut",CallingConvention=CallingConvention.StdCall)]
            public static extern int RouteSignalOut (System.IntPtr Instrument_Handle, string Channel_Name, int Route_Signal_From, int Route_Signal_To);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureSynchronization",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureSynchronization (System.IntPtr Instrument_Handle, string Channel_Name, int Synchronization_Source);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ConfigureCustomFIRFilterCoefficients",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureCustomFIRFilterCoefficients (System.IntPtr Instrument_Handle, string Channel_Name, int Number_of_Coefficients, System.Double[] Coefficients_Array);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetFIRFilterCoefficients",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetFIRFilterCoefficients (System.IntPtr Instrument_Handle, string Channel_Name, int Array_Size, System.Double[] Coefficients_Array, long[] Number_of_Coefficients_Read);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_InitiateGeneration",CallingConvention=CallingConvention.StdCall)]
            public static extern int InitiateGeneration (System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_AbortGeneration",CallingConvention=CallingConvention.StdCall)]
            public static extern int AbortGeneration (System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_SendSoftwareTrigger",CallingConvention=CallingConvention.StdCall)]
            public static extern int SendSoftwareTrigger (System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetHardwareState",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetHardwareState (System.IntPtr Instrument_Handle, out int state);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_WaitUntilDone",CallingConvention=CallingConvention.StdCall)]
            public static extern int WaitUntilDone (System.IntPtr Instrument_Handle, int maxTime);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_IsDone",CallingConvention=CallingConvention.StdCall)]
            public static extern int IsDone (System.IntPtr Instrument_Handle, out System.UInt16 Done);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ResetWithDefaults",CallingConvention=CallingConvention.StdCall)]
            public static extern int ResetWithDefaults (System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ResetDevice",CallingConvention=CallingConvention.StdCall)]
            public static extern int ResetDevice (System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetChannelName",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetChannelName (System.IntPtr Instrument_Handle, int Index, int BufferSize, System.Text.StringBuilder Channel_Name);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_Disable",CallingConvention=CallingConvention.StdCall)]
            public static extern int Disable (System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_self_test",CallingConvention=CallingConvention.StdCall)]
            public static extern int self_test (System.IntPtr Instrument_Handle, out short Self_Test_Result, System.Text.StringBuilder Self_Test_Message);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_revision_query",CallingConvention=CallingConvention.StdCall)]
            public static extern int revision_query (System.IntPtr Instrument_Handle, System.Text.StringBuilder Instrument_Driver_Revision, System.Text.StringBuilder Firmware_Revision);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetNextCoercionRecord",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetNextCoercionRecord (System.IntPtr Instrument_Handle, int Buffer_Size, System.Text.StringBuilder Coercion_Record);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_error_query",CallingConvention=CallingConvention.StdCall)]
            public static extern int error_query (System.IntPtr Instrument_Handle, out int Error_Code, System.Text.StringBuilder Error_Message);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ErrorHandler",CallingConvention=CallingConvention.StdCall)]
            public static extern int ErrorHandler (System.IntPtr Instrument_Handle, int Error_Code, System.Text.StringBuilder Error_Message);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetNextInterchangeWarning",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetNextInterchangeWarning (System.IntPtr Instrument_Handle, int Buffer_Size, System.Text.StringBuilder Interchange_Warning);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ClearInterchangeWarnings",CallingConvention=CallingConvention.StdCall)]
            public static extern int ClearInterchangeWarnings (System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ResetInterchangeCheck",CallingConvention=CallingConvention.StdCall)]
            public static extern int ResetInterchangeCheck (System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CloseExtCal",CallingConvention=CallingConvention.StdCall)]
            public static extern int CloseExtCal (System.IntPtr Instrument_Handle, int Action);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_SelfCal",CallingConvention=CallingConvention.StdCall)]
            public static extern int SelfCal (System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_InitializeAnalogOutputCalibration",CallingConvention=CallingConvention.StdCall)]
            public static extern int InitializeAnalogOutputCalibration (System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_WriteBinary16AnalogStaticValue",CallingConvention=CallingConvention.StdCall)]
            public static extern int WriteBinary16AnalogStaticValue (System.IntPtr Instrument_Handle, string Channel_Name, short Value);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CalAdjustMainPathPreAmpOffset",CallingConvention=CallingConvention.StdCall)]
            public static extern int CalAdjustMainPathPreAmpOffset (System.IntPtr Instrument_Handle, string Channel_Name, int Configuration, long[] Gain_DAC_Values, long[] Offset_DAC_Values, System.Double[] Measured_Outputs);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CalAdjustMainPathPreAmpGain",CallingConvention=CallingConvention.StdCall)]
            public static extern int CalAdjustMainPathPreAmpGain (System.IntPtr Instrument_Handle, string Channel_Name, int Configuration, long[] Main_DAC_Values, long[] Gain_DAC_Values, long[] Offset_DAC_Values, System.Double[] Measured_Outputs);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CalAdjustMainPathPostAmpGainAndOffset",CallingConvention=CallingConvention.StdCall)]
            public static extern int CalAdjustMainPathPostAmpGainAndOffset (System.IntPtr Instrument_Handle, string Channel_Name, int Configuration, long[] Main_DAC_Values, long[] Gain_DAC_Values, long[] Offset_DAC_Values, System.Double[] Measured_Outputs);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CalAdjustDirectPathGain",CallingConvention=CallingConvention.StdCall)]
            public static extern int CalAdjustDirectPathGain (System.IntPtr Instrument_Handle, string Channel_Name, long[] Main_DAC_Values, long[] Gain_DAC_Values, System.Double[] Measured_Outputs);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CalAdjustMainPathOutputImpedance",CallingConvention=CallingConvention.StdCall)]
            public static extern int CalAdjustMainPathOutputImpedance (System.IntPtr Instrument_Handle, string Channel_Name, int Configuration, System.Double Load_Impedance, System.Double Measured_Source_Voltage, System.Double Measured_Voltage_Across_Load);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CalAdjustDirectPathOutputImpedance",CallingConvention=CallingConvention.StdCall)]
            public static extern int CalAdjustDirectPathOutputImpedance (System.IntPtr Instrument_Handle, string Channel_Name, int Configuration, System.Double Load_Impedance, System.Double Measured_Source_Voltage, System.Double Measured_Voltage_Across_Load);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_InitializeOscillatorFrequencyCalibration",CallingConvention=CallingConvention.StdCall)]
            public static extern int InitializeOscillatorFrequencyCalibration (System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CalAdjustOscillatorFrequency",CallingConvention=CallingConvention.StdCall)]
            public static extern int CalAdjustOscillatorFrequency (System.IntPtr Instrument_Handle, System.Double Desired_Frequency, System.Double Measured_Frequency);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_InitializeCalADCCalibration",CallingConvention=CallingConvention.StdCall)]
            public static extern int InitializeCalADCCalibration (System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CalAdjustCalADC",CallingConvention=CallingConvention.StdCall)]
            public static extern int CalAdjustCalADC (System.IntPtr Instrument_Handle, System.Double[] Voltages_Measured_Externally, System.Double[] Voltages_Measured_With_CalADC);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ReadCalADC",CallingConvention=CallingConvention.StdCall)]
            public static extern int ReadCalADC (System.IntPtr Instrument_Handle, int Number_of_Reads_to_Average, System.UInt16 Return_Calibrated_Value, out System.Double Cal_ADC_Value);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetSelfCalSupported",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetSelfCalSupported (System.IntPtr Instrument_Handle, out System.UInt16 Self_Cal_Supported);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetSelfCalLastDateAndTime",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetSelfCalLastDateAndTime (System.IntPtr Instrument_Handle, out int Year, out int Month, out int Day, out int Hour, out int Minute);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetExtCalLastDateAndTime",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetExtCalLastDateAndTime (System.IntPtr Instrument_Handle, out int Year, out int Month, out int Day, out int Hour, out int Minute);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetSelfCalLastTemp",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetSelfCalLastTemp (System.IntPtr Instrument_Handle, out System.Double Temperature);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetExtCalLastTemp",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetExtCalLastTemp (System.IntPtr Instrument_Handle, out System.Double Temperature);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetExtCalRecommendedInterval",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetExtCalRecommendedInterval (System.IntPtr Instrument_Handle, out int Months);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ChangeExtCalPassword",CallingConvention=CallingConvention.StdCall)]
            public static extern int ChangeExtCalPassword (System.IntPtr Instrument_Handle, string Old_Password, string New_Password);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_SetCalUserDefinedInfo",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetCalUserDefinedInfo (System.IntPtr Instrument_Handle, string Info);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetCalUserDefinedInfo",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetCalUserDefinedInfo (System.IntPtr Instrument_Handle, string Info);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetCalUserDefinedInfoMaxSize",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetCalUserDefinedInfoMaxSize (System.IntPtr Instrument_Handle, out int Info_Size);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_ReadCurrentTemperature",CallingConvention=CallingConvention.StdCall)]
            public static extern int ReadCurrentTemperature (System.IntPtr Instrument_Handle, out System.Double Temperature);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_RestoreLastExtCalConstants",CallingConvention=CallingConvention.StdCall)]
            public static extern int RestoreLastExtCalConstants (System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CreateArbWaveform",CallingConvention=CallingConvention.StdCall)]
            public static extern int CreateArbWaveform (System.IntPtr Instrument_Handle, int Waveform_Size, System.Double[] Waveform_Data_Array, out int Waveform_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_CreateBinary16ArbWaveform",CallingConvention=CallingConvention.StdCall)]
            public static extern int CreateBinary16ArbWaveform (System.IntPtr Instrument_Handle, int Waveform_Size, short[] Waveform_Data_Array, out int Waveform_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_close",CallingConvention=CallingConvention.StdCall)]
            public static extern int close (System.IntPtr Instrument_Handle);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_error_message",CallingConvention=CallingConvention.StdCall)]
            public static extern int error_message (System.IntPtr Instrument_Handle, int Error_Code, System.Text.StringBuilder Error_Message_2);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetAttributeViInt32",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViInt32 (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out int Attribute_Value);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetAttributeViReal64",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViReal64 (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out System.Double Attribute_Value);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetAttributeViString",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViString (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, int Array_Size, System.Text.StringBuilder Attribute_Value);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetAttributeViBoolean",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViBoolean (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out System.UInt16 Attribute_Value);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetAttributeViSession",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViSession (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out System.IntPtr Attribute_Value);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_SetAttributeViInt32",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViInt32 (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, int Attribute_Value);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_SetAttributeViReal64",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViReal64 (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, System.Double Attribute_Value);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_SetAttributeViString",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViString (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, string Attribute_Value);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_SetAttributeViBoolean",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViBoolean (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, System.UInt16 Attribute_Value);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_SetAttributeViSession",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViSession (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, System.IntPtr Attribute_Value);
            
            [DllImport("niFgen_32.dll",EntryPoint="niFgen_GetError",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetError (System.IntPtr Instrument_Handle, out int Error_Code, int Error_Description_Buffer_Size, System.Text.StringBuilder Error_Description);
            
            public static int TestForError(System.IntPtr handle, int status)
            {
                if ((status < 0))
                {
                    PInvoke.ThrowError(handle, status);
                }
                return status;
            }
            
            public static int ThrowError(System.IntPtr handle, int code)
            {
                int status;
                int size = PInvoke.GetError(handle, out status, 0, null);
                System.Text.StringBuilder msg = new System.Text.StringBuilder();
                if ((size >= 0))
                {
                    msg.Capacity = size;
                    PInvoke.GetError(handle, out status, size, msg);
                }
                throw new System.Runtime.InteropServices.ExternalException(msg.ToString(), code);
            }
        }
    }
    
    public class niFgenConstants
    {
        
        public const int CalConfigMainPathFilterOff6db = 2;
        
        public const int CalConfigMainPathHighGain0db75ohms = 9;
        
        public const int CalConfigMainPathLowGain0db75ohms = 1;
        
        public const int CalConfigMainPathLowGain36db75ohms = 7;
        
        public const int RefIn = 1200;
        
        public const int RefClockExternal = 1;
        
        public const int WfmRampDown = 5;
        
        public const int ClockOut = 1009;
        
        public const int None = 1000;
        
        public const int External = 1;
        
        public const int UpdateClock = 1017;
        
        public const int CalConfigMainPathHighGain24db75ohms = 13;
        
        public const int RefOut = 1008;
        
        public const int CalConfigMainPathLowGain24db50ohms = 4;
        
        public const int WaveformPositionStart = 0;
        
        public const int CalConfigMainPathLowGain0db50ohms = 0;
        
        public const int CalConfigMainPathFilterOn3db = 6;
        
        public const int OutStartTrigger = 1004;
        
        public const int CalConfigMainPathLowGain12db = 1;
        
        public const int PllRefSource = 1003;
        
        public const int CalConfigMainPathLowGain36db50ohms = 6;
        
        public const int CalConfigDirectPath75ohms = 1;
        
        public const int Continuous = 2;
        
        public const int WfmSquare = 2;
        
        public const int CalConfigMainPathFilterOn12db = 9;
        
        public const int CalConfigMainPathLowGain12db50ohms = 2;
        
        public const int RefClockTtl7 = 118;
        
        public const int CalConfigMainPathLowGain36db = 3;
        
        public const int OperateContinuous = 0;
        
        public const int CalConfigMainPathHighGain0db50ohms = 8;
        
        public const int CalConfigMainPathFilterOn0db = 5;
        
        public const int WfmTriangle = 3;
        
        public const int CalConfigMainPathLowGain24db75ohms = 5;
        
        public const int OutputFunc = 0;
        
        public const int DivideDown = 1;
        
        public const int Synchronization = 1007;
        
        public const int Ttl3 = 114;
        
        public const int CalConfigMainPathLowGain0db = 0;
        
        public const int CalConfigMainPathFilterOff0db = 0;
        
        public const int Stepped = 3;
        
        public const int RefClockRtsiClock = 101;
        
        public const int ExtCalAbort = 0;
        
        public const int OutputSeq = 2;
        
        public const int PxiClk10 = 1201;
        
        public const int CalConfigMainPathFilterOn6db = 7;
        
        public const int Burst = 4;
        
        public const int CalConfigMainPathHighGain36db75ohms = 15;
        
        public const int Ttl5 = 116;
        
        public const int Ttl0 = 111;
        
        public const int Ttl1 = 112;
        
        public const int Ttl2 = 113;
        
        public const int OnboardReferenceClock = 1019;
        
        public const int Ttl4 = 115;
        
        public const int WfmRampUp = 4;
        
        public const int Ttl6 = 117;
        
        public const int Ttl7 = 118;
        
        public const int ClkIn = 1202;
        
        public const int CalConfigMainPathHighGain12db75ohms = 11;
        
        public const int CalConfigMainPathHighGain12db = 5;
        
        public const int Automatic = 2;
        
        public const int CalConfigDirectPath50ohms = 0;
        
        public const int CalConfigMainPathHighGain0db = 4;
        
        public const int WfmUser = 102;
        
        public const int HighResolution = 0;
        
        public const int Pfi0 = 1011;
        
        public const int Rtsi7 = 1010;
        
        public const int Pfi2 = 1013;
        
        public const int Rtsi5 = 146;
        
        public const int Rtsi4 = 145;
        
        public const int Rtsi3 = 144;
        
        public const int Rtsi2 = 143;
        
        public const int Rtsi1 = 142;
        
        public const int Rtsi0 = 141;
        
        public const int OutputFreqList = 101;
        
        public const int Single = 1;
        
        public const int BoardClock = 1006;
        
        public const int CalConfigMainPathFilterOn9db = 8;
        
        public const int CalConfigMainPathFilterOff12db = 4;
        
        public const int CalConfigMainPathHighGain24db = 6;
        
        public const int Pfi1 = 1012;
        
        public const int CalConfigMainPathHighGain36db = 7;
        
        public const int OutputArb = 1;
        
        public const int WaveformPositionCurrent = 1;
        
        public const int ExtCalCommit = 1;
        
        public const int RefClockInternal = 0;
        
        public const int CalConfigMainPathHighGain36db50ohms = 14;
        
        public const int SoftwareTrig = 2;
        
        public const int Marker = 1001;
        
        public const int CalConfigMainPathFilterOff3db = 1;
        
        public const int LittleEndian = 0;
        
        public const int CalConfigMainPathHighGain24db50ohms = 12;
        
        public const int CalConfigMainPathFilterOff9db = 3;
        
        public const int Pfi3 = 1014;
        
        public const int CalConfigMainPathLowGain12db75ohms = 3;
        
        public const int Immediate = 0;
        
        public const int WfmSine = 1;
        
        public const int PxiStar = 131;
        
        public const int Internal = 0;
        
        public const int Rtsi6 = 147;
        
        public const int WfmDc = 6;
        
        public const int CalConfigMainPathLowGain24db = 2;
        
        public const int DdcClkIn = 1203;
        
        public const int BigEndian = 1;
        
        public const int SyncOut = 1002;
        
        public const int CalConfigMainPathHighGain12db50ohms = 10;
    }
    
	[StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential)]
	public struct niFgenComplexF64
	{
    	public System.Double Real;
        
		public System.Double Imaginary;        
	}
    public enum niFgenProperties
    {
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        RangeCheck = 1050002,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        QueryInstrumentStatus = 1050003,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        Cache = 1050004,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        Simulate = 1050005,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        RecordCoercions = 1050006,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        InterchangeCheck = 1050021,
        
        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverDescription = 1050514,
        
        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverVendor = 1050513,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        SpecificDriverClassSpecMajorVersion = 1050515,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        SpecificDriverClassSpecMinorVersion = 1050516,
        
        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverPrefix = 1050302,
        
        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverRevision = 1050551,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        ChannelCount = 1050203,
        
        /// <summary>
        /// System.String
        /// </summary>
        SupportedInstrumentModels = 1050327,
        
        /// <summary>
        /// System.String
        /// </summary>
        GroupCapabilities = 1050401,
        
        /// <summary>
        /// System.String
        /// </summary>
        InstrumentManufacturer = 1050511,
        
        /// <summary>
        /// System.String
        /// </summary>
        InstrumentModel = 1050512,
        
        /// <summary>
        /// System.String
        /// </summary>
        InstrumentFirmwareRevision = 1050510,
        
        /// <summary>
        /// System.String
        /// </summary>
        LogicalName = 1050305,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        OperationMode = 1250005,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        OutputMode = 1250001,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        RefClockSource = 1250002,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        OutputEnabled = 1250003,
        
        /// <summary>
        /// System.Double
        /// </summary>
        OutputImpedance = 1250004,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        FuncWaveform = 1250101,
        
        /// <summary>
        /// System.Double
        /// </summary>
        FuncAmplitude = 1250102,
        
        /// <summary>
        /// System.Double
        /// </summary>
        FuncDcOffset = 1250103,
        
        /// <summary>
        /// System.Double
        /// </summary>
        FuncFrequency = 1250104,
        
        /// <summary>
        /// System.Double
        /// </summary>
        FuncStartPhase = 1250105,
        
        /// <summary>
        /// System.Double
        /// </summary>
        FuncDutyCycleHigh = 1250106,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        FuncBufferSize = 1150238,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        FuncMaxBufferSize = 1150239,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        FreqListHandle = 1150208,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        MaxNumFreqLists = 1150209,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        MinFreqListLength = 1150210,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        MaxFreqListLength = 1150211,
        
        /// <summary>
        /// System.Double
        /// </summary>
        MinFreqListDuration = 1150212,
        
        /// <summary>
        /// System.Double
        /// </summary>
        MaxFreqListDuration = 1150213,
        
        /// <summary>
        /// System.Double
        /// </summary>
        FreqListDurationQuantum = 1150214,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        ArbWaveformHandle = 1250201,
        
        /// <summary>
        /// System.Double
        /// </summary>
        ArbGain = 1250202,
        
        /// <summary>
        /// System.Double
        /// </summary>
        ArbOffset = 1250203,
        
        /// <summary>
        /// System.Double
        /// </summary>
        ArbSampleRate = 1250204,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        MaxNumWaveforms = 1250205,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        WaveformQuantum = 1250206,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        MinWaveformSize = 1250207,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        MaxWaveformSize = 1250208,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        DataTransferBlockSize = 1150241,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        FileTransferBlockSize = 1150240,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        DirectDmaEnabled = 1150244,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        DirectDmaWindowAddress = 1150274,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        DirectDmaWindowSize = 1150245,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        OspCicFilterEnabled = 1150257,
        
        /// <summary>
        /// System.Double
        /// </summary>
        OspCicFilterGain = 1150263,
        
        /// <summary>
        /// System.Double
        /// </summary>
        OspCicFilterInterpolation = 1150258,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        OspFirFilterEnabled = 1150255,
        
        /// <summary>
        /// System.Double
        /// </summary>
        OspFirFilterInterpolation = 1150256,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        OspOverflowErrorReporting = 1150268,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        OspOverflowStatus = 1150269,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        OspCarrierEnabled = 1150249,
        
        /// <summary>
        /// System.Double
        /// </summary>
        OspCarrierFrequency = 1150250,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        OspDataProcessingMode = 1150247,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        OspFirFilterType = 1150253,
        
        /// <summary>
        /// System.Double
        /// </summary>
        OspFirFilterFlatPassband = 1150261,
        
        /// <summary>
        /// System.Double
        /// </summary>
        OspFirFilterGaussianBt = 1150262,
        
        /// <summary>
        /// System.Double
        /// </summary>
        OspFirFilterRaisedCosineAlpha = 1150260,
        
        /// <summary>
        /// System.Double
        /// </summary>
        OspFirFilterRootRaisedCosineAlpha = 1150259,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        OspEnabled = 1150246,
        
        /// <summary>
        /// System.Double
        /// </summary>
        OspPreFilterGainI = 1150264,
        
        /// <summary>
        /// System.Double
        /// </summary>
        OspPreFilterGainQ = 1150265,
        
        /// <summary>
        /// System.Double
        /// </summary>
        OspPreFilterOffsetI = 1150266,
        
        /// <summary>
        /// System.Double
        /// </summary>
        OspPreFilterOffsetQ = 1150267,
        
        /// <summary>
        /// System.Double
        /// </summary>
        OspCarrierPhaseI = 1150251,
        
        /// <summary>
        /// System.Double
        /// </summary>
        OspCarrierPhaseQ = 1150252,
        
        /// <summary>
        /// System.Double
        /// </summary>
        OspIqRate = 1150248,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        ArbSequenceHandle = 1250211,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        MaxNumSequences = 1250212,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        MinSequenceLength = 1250213,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        MaxSequenceLength = 1250214,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        MaxLoopCount = 1250215,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        TriggerSource = 1250302,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        TriggerMode = 1150108,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        Synchronization = 1150111,
        
        /// <summary>
        /// System.Double
        /// </summary>
        LoadImpedance = 1150220,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        AnalogPath = 1150222,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        AnalogFilterEnabled = 1150103,
        
        /// <summary>
        /// System.Double
        /// </summary>
        FilterCorrectionFrequency = 1150104,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        DigitalFilterEnabled = 1150102,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        DigitalPatternEnabled = 1150101,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        DigitalFilterInterpolationFactor = 1150218,
        
        /// <summary>
        /// System.Double
        /// </summary>
        DigitalGain = 1150254,
        
        /// <summary>
        /// System.Double
        /// </summary>
        SyncDutyCycleHigh = 1150105,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        AnalogDataMask = 1150234,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        AnalogStaticValue = 1150235,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        DigitalDataMask = 1150236,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        DigitalStaticValue = 1150237,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        ClockMode = 1150110,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        UpdateClockSource = 1150106,
        
        /// <summary>
        /// System.Double
        /// </summary>
        RefClockFrequency = 1150107,
        
        /// <summary>
        /// System.Double
        /// </summary>
        ActualArbSampleRate = 1150109,
        
        /// <summary>
        /// System.Double
        /// </summary>
        SampleClockAbsoluteDelay = 1150231,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        ExportedSampleClockDivisor = 1150219,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        ExportedSampleClockTimebaseDivisor = 1150230,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        BusType = 1150215,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        VideoWaveformType = 1150216,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        MemorySize = 1150242,
        
        /// <summary>
        /// System.String
        /// </summary>
        SerialNumber = 1150243,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        DaqmxTask = 1150221,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        OscillatorPhaseDacValue = 1150232,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        ExternalClockDelayBinaryValue = 1150233,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        GainDacValue = 1150223,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        OffsetDacValue = 1150224,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        OscillatorFreqDacValue = 1150225,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        CalAdcInput = 1150227,
        
        /// <summary>
        /// System.Double
        /// </summary>
        PreAmplifierAttenuation = 1150228,
        
        /// <summary>
        /// System.Double
        /// </summary>
        PostAmplifierAttenuation = 1150229,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        CycleCount = 1250350,
        
        /// <summary>
        /// System.IntPtr
        /// </summary>
        IoSession = 1050322,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        PrimaryError = 1050101,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        SecondaryError = 1050102,
        
        /// <summary>
        /// System.String
        /// </summary>
        ErrorElaboration = 1050103,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        NumChannels = 1050203,
    }
}
